Package: MACSQuantifyR
Type: Package
Title: Fast treatment of MACSQuantify FACS data
Date: 08/10/2019
Version: 1.25.0
Author: Raphaël Bonnet [aut, cre], Marielle Nebout [dtc],Giulia Biondani [dtc], Jean-François Peyron[aut,ths], Inserm [fnd]
Maintainer: Raphaël Bonnet <raphael.bonnet@univ-cotedazur.fr>
Description: Automatically process the metadata of MACSQuantify FACS sorter. 
    It runs multiple modules: i) imports of raw file and graphical selection of duplicates in well plate, 
    ii) computes statistics on data and iii) can compute combination index.
Imports: readxl, graphics, tools, utils, grDevices, ggplot2, ggrepel,
        methods, stats, latticeExtra, lattice, rmarkdown, png, grid,
        gridExtra, prettydoc, rvest, xml2
biocViews: DataImport, Preprocessing, Normalization, FlowCytometry,
        DataRepresentation, GUI
License: Artistic-2.0
Encoding: UTF-8
RoxygenNote: 7.1.0
Suggests: knitr, testthat, R.utils, spelling
VignetteBuilder: knitr
Language: en-US
git_url: https://git.bioconductor.org/packages/MACSQuantifyR
git_branch: devel
git_last_commit: 1dffa00
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 21:45:19 UTC; biocbuild

### MACSQuant

#' The MACSQuant Class
#'
#' MACSQuant object contains all the data and the user parameters
#'
#' @slot my_data Contains the raw data
#' @slot my_data_sorted  Contains the sorted data
#' (according to replicates order)
#' @slot my_replicates_sorted  Contains the sorted matrix containing
#' replicates names
#' @slot experiment_name Contains the experiment name
#' given by the user
#' @slot statistics Contains the statistics for each condition
#' @slot combination.index.df data.frame that contains the outputs of
#' the combination_index function
#' @slot param.experiment list that contains the parameters relative
#' to the experiment (i.e, number of replicates,
#' number of conditions...)
#' @slot param.output  List that contains the parameters relative
#' to the report generation and outputs (i.e, save intermediary
#' results, generate full report..)
#'
#' @name MACSQuant
#' @rdname MACSQuant
#' @aliases MACSQuant-class
#' @exportClass MACSQuant
#'

MACSQuant <- setClass("MACSQuant",
        slots = c(my_data = "data.frame",
        my_data_sorted = "data.frame",
        my_replicates_sorted = "matrix",
        experiment_name = "character",
        statistics = "data.frame",
        combination.index.df = "data.frame",
        param.experiment = "list",
        param.output = "list"))

#' @export
#'
#' @importFrom ggplot2 aes element_text
#' ggplot ggtitle
#' theme theme_minimal xlab ylab
#' element_line geom_abline geom_hline geom_point
#' geom_vline scale_color_manual scale_size_manual
#' stat_smooth xlim ylim ggsave
#' @importFrom stats lm
#' @importFrom ggrepel geom_text_repel
#' @importFrom lattice cloud
#' @importFrom latticeExtra panel.3dbars
#'
#' @title compute combination index
#' @description
#' This function allows the user to compute combination index
#' on the drug combinations. This function also generates intermediary
#' plots and tables.
#' @name combination_index
#' @rdname combination_index
#' @aliases combination_index
#' @usage
#' combination_index(MACSQuant, ...)
#' @param MACSQuant object of class MACSQuant resulting of the function
#' load_maxQuant().
#' Contains the original data table
#' @param ... params for lattice cloud namely z and x for parameter screen
#' default for z and x are c(-110,-70) and argument xlab and ylab
#'
#' @examples
#' filepath <- system.file("extdata", "drugs.Rdata",
#'     package = "MACSQuantifyR")
#' load(filepath)
#' combination_index(MACSQuant)
#' @references
#' Chou, T. C. (2006). Theoretical basis, experimental design, and
#' computerized simulation of synergism and antagonism in drug
#' combination studies. \emph{Pharmacological reviews}, 58(3), 621-681.
#'
#' @return Several plots and combination index


combination_index <- function(MACSQuant, ...) {
    #parsing options
    save.files <- MACSQuant@param.output$save.files
    #parsing specific arguments
    l <- list(...)
    e <- new.env()
    if (length(l) > 0) {
        for (i in seq_len(length(l)))
        {
            assign(names(l)[[i]], l[[i]], envir = e)
        }
    }
    if (!"xlab" %in% names(e)) {
        e$xlab <- "Drug1"
    }
    if (!"ylab" %in% names(e)) {
        e$ylab <- "Drug2"
    }

    #indices of single drug conditions
    ind_d1 <- which(MACSQuant@param.experiment$doses != 0 &
        MACSQuant@param.experiment$doses.alt == 0)
    ind_d2 <- which(MACSQuant@param.experiment$doses == 0 &
        MACSQuant@param.experiment$doses.alt != 0)

    #doses and response (fa) of single drug conditions
    d <- MACSQuant@param.experiment$doses[ind_d1]
    fa <- MACSQuant@statistics$Fluo.percent.plus[ind_d1]
    d2 <- MACSQuant@param.experiment$doses.alt[ind_d2]
    fa2 <- MACSQuant@statistics$Fluo.percent.plus[ind_d2]

    #preparing dose-response plot
    dose_rep_df <- as.data.frame(rbind(cbind(d, fa), cbind(d2, fa2)))
    dose_rep_df <- data.frame(dose_rep_df)
    dose_rep_df$dataset <- c(rep("A", length(d)),
        rep("B", length(d2)))

    #doses for combo conditions
    doses1_c <- MACSQuant@param.experiment$doses[-c(ind_d1, ind_d2)]
    doses2_c <- MACSQuant@param.experiment$doses.alt[-c(ind_d1, ind_d2)]

    #response for combo conditions
    fa_c <- MACSQuant@statistics$Fluo.percent.plus[-c(ind_d1, ind_d2)]

    #adapting data to previously set options
    if (MACSQuant@param.experiment$control) {
        fa_c <- fa_c[-length(fa_c)]
    }


    combo_df <- data.frame(doses1_c, doses2_c, fa_c)

    #dose response plot
    p1 <- ggplot(data = dose_rep_df,
        aes(x = d, y = fa, col = dose_rep_df$dataset)) +
        geom_point(size = 3) +
        scale_color_manual(name = "Dataset", labels = c(e$xlab, e$xlab),
            values = c("lightblue", "orange")) +
        scale_size_manual(name = "Dataset", labels = c(e$xlab, e$xlab)) +
        xlab("Dose") + ylab("Response") +
        ggtitle("Dose-response curve") +
        theme_minimal() +
        theme(axis.title.x = element_text(
            face = "bold", colour = "#990000", size = 15),
        axis.title.y = element_text(
            face = "bold", colour = "#990000", size = 15),
        axis.text.x = element_text(size = 12, vjust = 0.5),
        axis.text.y = element_text(size = 12)
        )

    if (save.files == TRUE) {
        ggsave(paste(MACSQuant@param.output$path,
            "/outputMQ/dose_response_curve.png", sep = ""),
        width = 15.875, height = 15.875,
        units = "cm", plot = p1)
    }

    #median effect plot
    p2 <- ggplot(data = dose_rep_df,
        aes(x = log10(d), y = log10(fa / (1 - fa)),
            col = dose_rep_df$dataset)) + geom_point(size = 3) +
        scale_color_manual(name = "Dataset", labels = c("Drug1", "Drug2"),
            values = c("lightblue", "orange")) +
        scale_size_manual(name = "Dataset", labels = c("Drug1", "Drug2")) +
        xlab("Dose") + ylab("Response") +
        ggtitle("Median effect plot (log dose-response)") +
        theme_minimal() +
        theme(axis.title.x = element_text(
            face = "bold", colour = "#990000", size = 15),
        axis.title.y = element_text(
            face = "bold", colour = "#990000", size = 15),
        axis.text.x = element_text(size = 12, vjust = 0.5),
        axis.text.y = element_text(size = 12)
        ) +
        stat_smooth(method = "lm", se = FALSE, n = 80,
            fullrange = TRUE, span = 50) +
        geom_hline(aes(yintercept = 0), size = 0.2, linetype = 2) +
        geom_vline(aes(xintercept = 0), size = 0.2, linetype = 2)

    if (save.files == TRUE) {
        ggsave(paste(MACSQuant@param.output$path,
            "/outputMQ/median_effect.png", sep = ""),
        width = 15.875, height = 15.875,
        units = "cm", plot = p2)
    }

    #linear regression on median effect plot data
    fit1 <- lm(log10(fa / (1 - fa)) ~ log10(d))
    fit2 <- lm(log10(fa2 / (1 - fa2)) ~ log10(d2))

    #extracting coefficients from regression
    m1 <- as.numeric(fit1$coefficients[2])
    b1 <- as.numeric(fit1$coefficients[1])
    m2 <- as.numeric(fit2$coefficients[2])
    b2 <- as.numeric(fit2$coefficients[1])

    #IC50 computation
    IC50_1 <- 10^(-b1 / m1)
    IC50_2 <- 10^(-b2 / m2)

    #Combination index computation
    DX1 <- IC50_1 * (fa_c / (1 - fa_c))^(1 / m1)
    DX2 <- IC50_2 * (fa_c / (1 - fa_c))^(1 / m1)
    CI <- (doses1_c / DX1) + (doses2_c / DX2)

    #normalization for isobologram plot
    doses1_c_norm <- (doses1_c / DX1)
    doses2_c_norm <- (doses2_c / DX2)
    DRI_1 <- (DX1 / doses1_c)
    DRI_2 <- (DX2 / doses2_c)

    #decision regarding synergism
    case_cond <- character(length(CI))
    col <- character(length(CI))

    for (i in seq_len(length(CI)))
    {
        if (CI[i] <= 0.1) {
            case_cond[i] <- "Very Strong Synergism"
            col[i] <- "darkred"
        } else if (CI[i] > 3.3) {
            case_cond[i] <- "Strong Antagonism"
            col[i] <- "black"
        } else if (CI[i] > 0.1 & CI[i] <= 0.3) {
            case_cond[i] <- "Strong Synergism"
            col[i] <- "red"
        } else if (CI[i] > 0.3 & CI[i] <= 0.7) {
            case_cond[i] <- "Synergism"
            col[i] <- "orange"
        } else if (CI[i] > 0.7 & CI[i] <= 0.9) {
            case_cond[i] <- "Moderate Synergism"
            col[i] <- "yellow"
        } else if (CI[i] > 1.1 & CI[i] <= 1.45) {
            case_cond[i] <- "Moderate Antagonism"
            col[i] <- "lightgrey"
        } else if (CI[i] > 1.45 & CI[i] <= 3.3) {
            case_cond[i] <- "Antagonism"
            col[i] <- "darkgrey"
        } else if (CI[i] > 0.9 & CI[i] <= 1.1) {
            case_cond[i] <- "Aditivity"
            col[i] <- "green"
        }
    }

    #isobologram plot prep
        #possible ploted situations
    cases <- c("Very Strong Synergism", "Strong Synergism",
        "Synergism", "Moderate Synergism", "Aditivity",
        "Moderate Antagonism", "Antagonism",
        "Strong Antagonism")

        #corresponding colors
    cases_col <- c("darkred", "red",
        "orange", "yellow", "green",
        "lightgrey", "darkgrey", "black")

        #preparing data for plot
    CI_df <- data.frame("DX1" = doses1_c_norm, "DX2" = doses2_c_norm,
        "Decision" = case_cond, "Color" = col, stringsAsFactors = FALSE)
    labels_ci <- factor(cases[!is.na(match(cases, CI_df$Decision))])
    labels_col <- factor(cases_col[!is.na(match(cases,
        CI_df$Decision))])

    #isobologram plot
    p3 <- ggplot(data = CI_df, aes(x = doses2_c_norm, y = doses1_c_norm)) +
        geom_point(size = 3, colour = col) +
        xlim(0, 1) +
        ylim(0, 1) +
        theme_minimal() +
        ggtitle("Normalized Isobologram") +
        xlab("Normalized Dose 1") + ylab("Normalized Dose 2") +
        theme(axis.title.x = element_text(
            face = "bold", colour = "#990000", size = 15),
        axis.title.y = element_text(
            face = "bold", colour = "#990000", size = 15),
        axis.text.x = element_text(size = 12, vjust = 0.5),
        axis.text.y = element_text(size = 12),
        axis.line = element_line(colour = "black",
            size = 0.5, linetype = "solid")) +
        geom_abline(intercept = 1, slope = -1, color = "red") +
        geom_text_repel(aes(label = CI_df$Decision),
            size = 2, col = CI_df$Color)
    if (save.files == TRUE) {
        ggsave(paste(MACSQuant@param.output$path,
            "/outputMQ/isobologram.png", sep = ""),
        width = 15.875, height = 15.875,
        units = "cm", plot = p3)

    }

    #preparing arguments for 3D combinations barplots
        #combo conditions index
    Condition <-
        seq_len(MACSQuant@param.experiment$number_of_conditions)[-c(ind_d1,
            ind_d2)]

    #results under df from
    MACSQuant@combination.index.df <- data.frame(combo_df, CI, doses1_c_norm,
        doses2_c_norm, CI_df, Condition, stringsAsFactors = FALSE)

    #preparing arguments for 3D combinations barplots
        #color correspondence
    col <- rep("white", MACSQuant@param.experiment$number_of_conditions)
    col[MACSQuant@combination.index.df$Condition] <-
        MACSQuant@combination.index.df$Color

    if (save.files == TRUE) {
        write.table(MACSQuant@combination.index.df,
            paste(MACSQuant@param.output$path,
                "/outputMQ/combination_index.txt ", sep = ""),
            sep = "\t")
    }

    # 3D combination barplots
    flav <- "percent"
    plt.labels <- MACSQuant@param.output$plt.labels
    p4 <- grid.arrange(barplot_data(MACSQuant,
        plt.col = col,
        plt.flavour = flav,
        plt.labels = plt.labels,
        plt.combo = TRUE,
        plt.3D.only = TRUE,
        ...))

    # p <- gridExtra::arrangeGrob(p3, p4, ncol = 2)

    if (save.files == TRUE) {
        ggsave(paste(MACSQuant@param.output$path,
            "/outputMQ/barplot_combination_index.png", sep = ""),
        width = 15.875, height = 15.875,
        units = "cm", plot = p4)
    }

    plot(p1)
    plot(p2)
    plot(p3)
    grid.arrange(p4)
    return(MACSQuant)
}

#' @export
#' @importFrom methods new
#' @title Create a new MACSQuant object
#' @description
#' The user can create a new custom MACSQuant object
#' This function is also used in internal code for
#' MACSQuant initialization
#' @name new_class_MQ
#' @aliases new_class_MQ
#' @usage
#' #initialize empty MACSQuant object
#' new_class_MQ(my_data=NULL,my_data_sorted=NULL,my_replicates_sorted=NULL,
#' experiment_name=NULL,statistics=NULL,combination.index.df=NULL,
#' number_of_replicates=NULL,number_of_conditions=NULL,doses=NULL,
#' doses.alt=NULL,c_names=NULL, control=NULL,plt.title=NULL,
#' plt.labels=NULL,plt.col=NULL,save.files=NULL,path=tempdir())
#' #initialize custom MACSQuant object
#' new_class_MQ(my_data,my_data_sorted=NULL,my_replicates_sorted=NULL,
#' experiment_name=NULL,statistics=NULL,combination.index.df=NULL,
#' number_of_replicates=NULL,number_of_conditions=NULL,
#' doses=NULL,doses.alt=NULL, c_names=NULL,control=NULL,plt.title=NULL,
#' plt.labels=NULL,plt.col=NULL, save.files=NULL,path=tempdir())
#' @param my_data Contains the raw data
#' @param my_data_sorted  Contains the sorted data
#' (according to replicates order)
#' @param my_replicates_sorted  Contains the sorted matrix containing
#' replicates names
#' @param experiment_name User defined experiment named. Used for the
#' report generation
#' @param statistics Contains the statistics for each condition
#' @param combination.index.df data.frame that contains the outputs of
#' the combination_index function
#' @param number_of_replicates For each condition, the number of duplicates
#' (must be the same for all conditions)
#' @param number_of_conditions The number of conditions tested
#' (eg: Drug 1 alone, Drug 2 alone)
#' @param doses  Numeric vector representing doses for each conditions
#' @param doses.alt In case of interaction test second dose vector
#' @param c_names Vector containing experiment names
#' @param control logical: is there a control in this experiment
#' (eg: Staurosporin)
#' @param plt.title Title of the experiment to add to the barplot
#' @param plt.labels legend labels for the bar plot
#' @param plt.col color vector for the graphical representations
#' @param save.files Used to save the image in the output folder
#' @param path path of the experiment output folder (default '.')
#'
#' @examples
#' # initialize empty MACSQuant object
#' new_class_MQ()
#' # initialize custom MACSQuant object
#' my_data <- data.frame(character(length = 10), character(length = 10),
#'     numeric(length = 10), numeric(length = 10))
#' names(my_data) <- c("Full path", "WID", "%-#", "Count/mL")
#' new_class_MQ(my_data)
#' @return A formatted report file along with intermediates results


new_class_MQ <- function(my_data = NULL,
                        my_data_sorted = NULL,
                        my_replicates_sorted = NULL,
                        experiment_name = NULL,
                        statistics = NULL,
                        combination.index.df = NULL,
                        number_of_replicates = NULL,
                        number_of_conditions = NULL,
                        doses = NULL,
                        doses.alt = NULL,
                        c_names = NULL,
                        control = NULL,
                        plt.title = NULL,
                        plt.labels = NULL,
                        plt.col = NULL,
                        save.files = NULL,
                        path = tempdir()) {
    if (is.null(my_data)) {
        my_data <- data.frame()
    }
    if (is.null(my_data_sorted)) {
        my_data_sorted <- data.frame()
    }
    if (is.null(my_replicates_sorted)) {
        my_replicates_sorted <- matrix()
    }
    if (is.null(experiment_name)) {
        experiment_name <- character()
    }
    if (is.null(statistics)) {
        statistics <- data.frame()
    }
    if (is.null(combination.index.df)) {
        combination.index.df <- data.frame()
    }

    if (is.null(number_of_replicates)) {
        number_of_replicates <- 0
    }
    if (is.null(number_of_conditions)) {
        number_of_conditions <- 0
    }
    if (is.null(doses)) {
        doses <- numeric()
    }
    if (is.null(doses.alt)) {
        doses.alt <- numeric()
    }
    if (is.null(c_names)) {
        c_names <- character()
    }
    if (is.null(control)) {
        control <- FALSE
    }
    if (is.null(save.files)) {
        save.files <- FALSE
    }
    if (is.null(plt.title)) {
        plt.title <- character()
    }
    if (is.null(plt.labels)) {
        plt.labels <- character()
    }
    if (is.null(plt.col)) {
        plt.col <- character()
    }
    if (path == tempdir() | is.null(path)) {
        message('You did not specify any path for the ouput directory yet.')
        message(paste('Files will be stored at a temporary path: ',
        tempdir(),'/outputMQ',sep=""))
        message('If you want to retreive output files specify a path using the setPath() function.')
    } else if (path=='output_path')
    {
      path=tempdir()
    }


    MACSQuant <- new(Class = "MACSQuant",
        my_data = my_data,
        my_data_sorted = my_data_sorted,
        my_replicates_sorted = my_replicates_sorted,
        experiment_name = experiment_name,
        statistics = statistics,
        combination.index.df = combination.index.df,
        param.experiment = list(
                number_of_replicates = number_of_replicates,
                number_of_conditions = number_of_conditions,
                doses = doses,
                doses.alt = doses.alt,
                c_names = c_names,
                control = control),
                param.output = list(
                plt.title = plt.title,
                plt.labels = plt.labels,
                save.files = save.files,
                path = path
    ))

    return(MACSQuant)
}

# Tests for functions dependent on a MACSQuant object
set.seed(42)

# load a minimal example data set (subset of nbt dataset)
filepath <- system.file("extdata", "drugs.xlsx",
    package = "MACSQuantifyR")


# Tests for object creation (via new/Setup)
# --------------------------------------------------------------------------------

# Generate Seurat object

MACSQuant <- new(Class = "MACSQuant",
    my_data = data.frame(),
    my_data_sorted = data.frame(),
    statistics = data.frame(),
    param.experiment = list(),
    param.output = list())
MACSQuant@param.experiment$number_of_replicates <- 0
MACSQuant@param.experiment$number_of_conditions <- 0
MACSQuant@param.experiment$doses <- numeric()
MACSQuant@param.experiment$control <- logical()
MACSQuant@param.experiment$c_names <- character()
MACSQuant@param.output$save.files <- logical()

context("Object creation")

test_that("object initialization creates MACSQuant object", {
    expect_is(MACSQuant, "MACSQuant")
})

context("Object creation: subtypes")

test_that("entered parameters set correctly", {
    expect_true(is.data.frame(MACSQuant@my_data))
    expect_true(is.data.frame(MACSQuant@my_data_sorted))
    expect_true(is.matrix(MACSQuant@my_replicates_sorted))
    expect_true(is.data.frame(MACSQuant@statistics))
    expect_true(is.character(MACSQuant@experiment_name))
    expect_true(is.data.frame(MACSQuant@combination.index.df))
})

MACSQuant=new_class_MQ()
context("object initalization")
test_that("object parameters init correctly",{
    expect_true(is.numeric(MACSQuant@param.experiment$number_of_replicates))
    expect_true(is.numeric(MACSQuant@param.experiment$number_of_conditions))
    expect_true(is.logical(MACSQuant@param.experiment$control))
    expect_true(is.character(MACSQuant@param.experiment$c_names))
    expect_true(is.numeric(MACSQuant@param.experiment$doses))
    expect_true(is.numeric(MACSQuant@param.experiment$doses.alt))
    expect_true(is.character(MACSQuant@param.output$plt.title))
    expect_true(is.character(MACSQuant@param.output$plt.labels))
    expect_true(is.character(MACSQuant@param.output$path))
    expect_true(is.logical(MACSQuant@param.output$save.files))
})


context("Object creation: slot names")
test_that("slots names matches", {
    expect_equal(names(MACSQuant@param.experiment),
        c("number_of_replicates",
            "number_of_conditions",
            "doses",
            "doses.alt",
            "c_names",
            "control"))
    expect_equal(names(MACSQuant@param.output),
        c("plt.title",
         "plt.labels",
         "save.files",
         "path"))
})

#' @export
#' @importFrom rmarkdown render
#' @importFrom png readPNG
#' @importFrom grid grid.raster
#' @importFrom gridExtra grid.arrange
#'
#' @title Word report generation
#' @description
#'
#' Allows the user to generate a report at every
#' steps of the analysis
#'
#' Also generates a complete report with the graphics

#' @name generate_report
#' @rdname generate_report
#' @aliases generate_report
#' @usage
#' generate_report(MACSQuant)
#' @param MACSQuant object of class MACSQuant resulting of the function
#' load_maxQuant().
#' Contains the original data table
#' @examples
#' drugs_R_image <- system.file("extdata",
#'     "drugs.RDS",
#'     package = "MACSQuantifyR")
#' MACSQuant <- readRDS(drugs_R_image)
#' generate_report(MACSQuant)
#' @return A formatted report


generate_report <- function(MACSQuant) {
    dir_path <- paste(MACSQuant@param.output$path, "/outputMQ/", sep = "")

    if (dir.exists(dir_path)) {

        saveRDS(MACSQuant, paste(dir_path, "MACSQuant.RDS", sep = ""))

        filepath <- system.file("rmd", "generate_report.rmd",
            package = "MACSQuantifyR")

        render(filepath, "word_document", output_file =
            paste(dir_path, "results.docx", sep = ""),
        params = list(exp = MACSQuant@experiment_name,
            path = MACSQuant@param.output$path))
    } else {
        warning("Report not generated!")
        warning("./outputMQ not found. Please be sure to be in the
                correct directory")
    }
}

#' @export setPath
#'
#' @title sets custom output path
#' @description
#' This function allows the user to set the output directory path
#' @name setPath
#' @rdname setPath
#' @aliases setPath
#' @usage
#' setPath(MACSQuant,path=NULL)
#' @param MACSQuant object of class MACSQuant resulting of the function
#' load_maxQuant().
#' Contains the original data table
#' @param path user defined path, default is tempd
#' @examples
#' filepath <- system.file("extdata", "SingleDrugs.xlsx",
#'     package = "MACSQuantifyR")
#' #MACSQuant = load_MACSQuant(filepath)
#' user_path="."
#' #MACSQuant = setPath(MACSQuant,path=user_path)
#' @return object of class MACSQuant with updated path

setPath = function(MACSQuant,path=NULL)
{
    if (!is.null(path))
    {
    MACSQuant@param.output$path=path
    }
    else
    {
    message('You did not specify any path for the ouput directory yet')
    message(paste('Files will be stored at a temporary path: ',
                      tempdir(),'/outputMQ',sep=""))
    message('If you want to retreive output files specify a path')
    }
return(MACSQuant)
}


#' @export rData
#'
#' @title accessor function to access raw data
#' @description
#' This function allows the user to access raw data table
#' @name rData
#' @rdname rData
#' @aliases rData
#' @usage
#' rData(MACSQuant)
#' @param MACSQuant object of class MACSQuant resulting of the function
#' load_maxQuant().
#' Contains the original data table
#' @examples
#' filepath <- system.file("extdata", "SingleDrugs.xlsx",
#'     package = "MACSQuantifyR")
#' #MACSQuant = load_MACSQuant(filepath)
#'
#' #rData(MACSQuant)
#' @return the raw data table

rData = function(MACSQuant)
{
    return(MACSQuant@my_data)
}

#' @export sorted
#'
#' @title accessor function to access sorted data
#' @description
#' This function allows the user to access sorted data table
#' @name sorted
#' @rdname sorted
#' @aliases sorted
#' @usage
#' sorted(MACSQuant)
#' @param MACSQuant object of class MACSQuant resulting of the function
#' load_maxQuant().
#' Contains the original data table
#' @examples
#' filepath <- system.file("extdata", "SingleDrugs.xlsx",
#'     package = "MACSQuantifyR")
#' #MACSQuant = load_MACSQuant(filepath)
#'
#' #sorted(MACSQuant)
#' @return the raw data table

sorted = function(MACSQuant)
{
    return(MACSQuant@my_data_sorted)
}

#' @export load_MACSQuant
#' @importFrom readxl read_excel
#' @importFrom tools file_ext
#' @importFrom methods new
#' @importFrom xml2 read_html
#' @importFrom rvest html_table
#' @title Load xls file from maxQuant 96-well-plate device
#' @name load_MACSQuant
#' @rdname load_MACSQuant
#' @aliases load_MACSQuant
#' @usage
#' load_MACSQuant(filepath,sheet_name= NULL,MACSQuant.obj= NULL)
#' @param filepath path of the excel file
#' @param sheet_name Name of the sheet to load
#' (optional, first sheet is default)
#' @param MACSQuant.obj object of class MACSQuant
#' @examples
#' filepath <- system.file("extdata", "SingleDrugs.xlsx",
#'     package = "MACSQuantifyR")
#' # load_MACSQuant(filepath)
#' @return An object called MACSQuant of class MACSQuant containing
#' variable my_data that corresponds to the data of the excel file in R

# source("./R/function_toolbox.R")

load_MACSQuant <- function(filepath, sheet_name = NULL, MACSQuant.obj = NULL) {
    ext <- c("xls", "xlsx","htm")
    # check for correct extention type and file

    if (!file.exists(filepath)) {
        stop("File or variable not found")
    } else if (!file_ext(filepath) %in% ext) {
        stop("File compatibility error, try xls, xlsx or htm files")
    } else {
        my_data <- tryCatch(
            {
                message('ok')
                tmp_data=read_excel(filepath, sheet_name)
                tmp_data=as.data.frame(tmp_data)
            },
            error=function(cond) {
                file_htm=read_html(filepath)
                htm_data=html_table(file_htm,header=TRUE)
                names_col=names(htm_data[[1]])

                list_paths=unlist(htm_data[[1]][,1])

                tmp_data=data.frame(list_paths,
                                unlist(htm_data[[1]][,2]),
                                unlist(htm_data[[1]][,3]),
                                unlist(htm_data[[1]][,4]),
                                stringsAsFactors = FALSE)
                names(tmp_data)=names_col
                return(tmp_data)
            }
        )
        # data <- data.frame(my_data,stringsAsFactors = FALSE)
        # names(data)[1]="Full path"
        # names(data)[3]='Pct'
        # names(data)[4]='Count/mL'
        data=my_data

        blank_lines=which(data$WID=="---")
        if (length(blank_lines)>0)
        {
            data=data[-c(blank_lines),]
        }
        for (i in c(3,4)){

            data[,i]=gsub(",",".",data[,i])
            data[,i]=gsub("\\s","",data[,i])
            data[,i]=iconv( data[,i], 'utf-8', 'ascii', sub='')
            data[,i]=as.numeric(data[,i])
        }
        if (dim(data)[2] != 4) {
            # is the data a MQ file?
            stop(paste(
                "Check your data file, column missing.",
                "Columns shoud be 'Full path','WID','%-#','Count/mL'"
            ),
            sep = " "
            )
        }
        if (sum((names(data) == c("Full path", "WID",'%-#', "Count/mL"))) !=
            4) {
            stop(paste("Check your data file,",
                "column names shoud be 'Full path','WID','%-#','Count/mL'",
                sep = " "
            ))
        }
        message("--> Done: data loaded")
        message("--> Done: data stored in variable MACSQuant@my_data")
        message(paste("...You can now run",
            "on_plate_selection(MACSQuant,num_replicates,number_of_conditions)",
            "with your replicates and conditions numbers...",
            sep = " "
        ))
        if (is.null(MACSQuant.obj)) {
            MACSQuant <- new_class_MQ()
        } else {
            MACSQuant <- MACSQuant.obj
        }

        MACSQuant@my_data <- data

        # assign("my_data", data, envir = .GlobalEnv)
        # asssigning data to my_data
    }
    return(MACSQuant)
}

load_MACSQuant.internal <- function(filepath, sheet_name = NULL, MACSQuant.obj = NULL) {
  ext <- c("xls", "xlsx","htm")
  # check for correct extention type and file

  if (!file.exists(filepath)) {
    stop("File or variable not found")
  } else if (!file_ext(filepath) %in% ext) {
    stop("File compatibility error, try xls, xlsx or htm files")
  } else {
    my_data <- tryCatch(
      {
        message('ok')
        tmp_data=read_excel(filepath, sheet_name)
        tmp_data=as.data.frame(tmp_data)
      },
      error=function(cond) {
        file_htm=read_html(filepath)
        htm_data=html_table(file_htm,header=TRUE)
        names_col=names(htm_data[[1]])

        list_paths=unlist(htm_data[[1]][,1])

        tmp_data=data.frame(list_paths,
                            unlist(htm_data[[1]][,2]),
                            unlist(htm_data[[1]][,3]),
                            unlist(htm_data[[1]][,4]),
                            stringsAsFactors = FALSE)
        names(tmp_data)=names_col
        return(tmp_data)
      }
    )
    # data <- data.frame(my_data,stringsAsFactors = FALSE)
    # names(data)[1]="Full path"
    # names(data)[3]='Pct'
    # names(data)[4]='Count/mL'
    data=my_data

    blank_lines=which(data$WID=="---")
    if (length(blank_lines)>0)
    {
      data=data[-c(blank_lines),]
    }
    for (i in c(3,4)){

      data[,i]=gsub(",",".",data[,i])
      data[,i]=gsub("\\s","",data[,i])
      data[,i]=iconv( data[,i], 'utf-8', 'ascii', sub='')
      data[,i]=as.numeric(data[,i])
    }
    if (dim(data)[2] != 4) {
      # is the data a MQ file?
      stop(paste(
        "Check your data file, column missing.",
        "Columns shoud be 'Full path','WID','%-#','Count/mL'"
      ),
      sep = " "
      )
    }
    if (sum((names(data) == c("Full path", "WID",'%-#', "Count/mL"))) !=
        4) {
      stop(paste("Check your data file,",
                 "column names shoud be 'Full path','WID','%-#','Count/mL'",
                 sep = " "
      ))
    }
    message("--> Done: data loaded")
    message("--> Done: data stored in variable MACSQuant@my_data")
    message(paste("...You can now run",
                  "on_plate_selection(MACSQuant,num_replicates,number_of_conditions)",
                  "with your replicates and conditions numbers...",
                  sep = " "
    ))
    if (is.null(MACSQuant.obj)) {
      MACSQuant <- new_class_MQ()
    } else {
      MACSQuant <- MACSQuant.obj
    }

    MACSQuant@my_data <- data

    # assign("my_data", data, envir = .GlobalEnv)
    # asssigning data to my_data
  }
  return(MACSQuant)
}

# Tests for functions dependent on import data
library(tools)
set.seed(42)

filepath <- system.file("extdata", "drugs.xlsx", package = "MACSQuantifyR")


# Tests for object import
# --------------------------------------------------------------------------------
context("Object creation")
MACSQuant <- load_MACSQuant(filepath)


test_that("data is imported correctly", {
    expect_equal(dim(MACSQuant@my_data)[2], 4)
    expect_true(dim(MACSQuant@my_data)[1] > 0)
    expect_equal(colnames(MACSQuant@my_data), c("Full path", "WID", "%-#", "Count/mL"))
})

test_that("filename is correctly formated", {
    expect_match(file_ext(filepath), "^xls$|^xlsx$")
})

# Tests for functions dependent on replicate sorting
set.seed(43)

filepath <- system.file("extdata", "drugs.xlsx", package = "MACSQuantifyR")

number_of_replicates <- 3
number_of_conditions <- 18


filepath <- system.file("extdata", "drugs.xlsx", package = "MACSQuantifyR")
# Tests for object import
# --------------------------------------------------------------------------------
context("Object integrity before running function")
MACSQuant <- load_MACSQuant(filepath)
MACSQuant@param.output$c_names <- c(paste("cond", rep(1:18), sep = " "))

test_that("required fiels correct", {
    expect_true(unique(dim(MACSQuant@my_data) != c(0, 0)))
    expect_true(unique(dim(MACSQuant@my_data_sorted) == c(0, 0)))
    expect_true(unique(dim(MACSQuant@statistics) == c(0, 0)))
    expect_true(length(MACSQuant@param.experiment$number_of_replicates) != 0)
    expect_true(length(MACSQuant@param.experiment$number_of_conditions) != 0)
    expect_equal(length(MACSQuant@param.output$c_names), number_of_conditions)
})

create_output_folder <- function(MACSQuant) {
    # Create folder containing various output files
    # and variables

    if (length(MACSQuant@param.output$path) > 0) {
        if (!dir.exists(MACSQuant@param.output$path))
        {stop("Provided path does not exists, please sepecify a valid path")}
        path <- paste(MACSQuant@param.output$path, "/outputMQ", sep = "")
    } else {
        paste(tempdir(),"/outputMQ",sep="")
        message('You did not specify any path for the ouput directory yet')
        message(paste('Files will be stored at a temporary path: ',
                      tempdir(),'/outputMQ',sep=""))
        message('If you want to retreive output files specify a path')
    }
    if (!dir.exists(file.path(path))) {
        dir.create(file.path(path))
        message(paste("--> Done: Folder ",tempdir(),'/outputMQ', " created",sep=""))
    }
    return(MACSQuant)
}

init_GUI <- function()
# intialize GUI plate plot for user to select replicates on
{
    well_letter <- sort(toupper(letters[seq_len(8)]), decreasing = TRUE)
    df <- data.frame(df2 = seq_len(12), df1 = c(
        rep(1, 12), rep(2, 12),
        rep(3, 12), rep(4, 12), rep(5, 12), rep(6, 12), rep(7, 12), rep(
                8,
                12
        )
    ))
    rownames(df) <- vapply(toupper(letters[seq(8, 1)]), function(x) {
        paste(x, seq(12:1), sep = "")
    }, character(12))
    # TODO external X11()
    par(mar = c(3.1, 3.1, 3.1, 9), xpd = TRUE)
    plot(df,
        yaxt = "n", xaxt = "n", xlab = "", ylab = "", axes = FALSE,
        ylim = c(-0.49, 8.49), lwd = 3, pch = 21, cex = 4.5, col = "lightblue"
    )
    title("Well plate")
    axis(2, at = seq_len(8), labels = well_letter, las = 2, line = "1")
    axis(1, at = seq_len(12), labels = seq_len(12), line = "-2.5")
    text(df, labels = rownames(df), cex = 0.8, font = 1)
    return(well_letter)
}

to_well_names <- function(point_matrix, col, well_letter) {
    # interprete locations plot and return vector containing
    # the replicates names
    coordinates_raw <- unlist(point_matrix)
    coordinates_mat <- matrix(coordinates_raw, ncol = 2)
    coordinates_mat <- round(coordinates_mat)
    points(coordinates_mat, lwd = 1, pch = 21, cex = 3.2, col = col)
    coordinates_mat[, 2] <- well_letter[coordinates_mat[, 2]]
    coordinates_names <- paste(coordinates_mat[, 2], coordinates_mat[, 1],
        sep = ""
    )
    return(coordinates_names)
}

match_id_line <- function(MACSQuant, wid_vector) {
    # match replicate id in raw data table (my_data)
    # returns indices in raw data
    l.indices=lapply(wid_vector,
                FUN = function(j){which(MACSQuant@my_data$WID == j)})
    matched=unlist(l.indices)
    return(matched)
}

compute_statistics <- function(MACSQuant,
                                lines,
                                stats = "mean") {
    data_selected <- MACSQuant@my_data[lines, ]
    Counts <- c()
    Percent <- c()
    rep.indices=seq(1, MACSQuant@param.experiment$number_of_replicates * 2,
                2)
    c.list=lapply(rep.indices,
        function(rep){data_selected$`Count/mL`[rep] -
        data_selected$`Count/mL`[rep + 1]}
        )
    Counts=unlist(c.list)

    p.list=lapply(rep.indices,
        function(rep){(data_selected$`%-#`[rep + 1]) / 100}
    )
    Percent=unlist(p.list)

    Full.path.first <- unlist(strsplit(
        data_selected$`Full path`[1],
        "\\\\P1"
    ))
    WID.first <- sort(data_selected$WID)[1]

    if (stats == "mean") {
        Count.minus <- mean(Counts)
        Percent.plus <- mean(Percent)
    } else if (stats == "median") {
        Count.minus <- median(Counts)
        Percent.plus <- median(Percent)
    } else {
        stop(paste("Values for argument stats",
                "should be c('mean','median'). Other not supported",
                sep = " "
        ))
    }
    sd_count <- sd(Counts)
    Percent.minus <- 1 - Percent.plus
    sd_percent <- sd(Percent)

    results <- c(
        Full.path.first, WID.first, Percent.plus, Percent.minus,
        sd_percent, Count.minus, sd_count
    )
    return(results)
}



order_data <- function(MACSQuant) {

    # is_variable_missing=(check_variables()) if
    # (length(is_variable_missing)>0){stop(is_variable_missing)}

    # pre allocate indice matrix
    indice_matrix <- matrix(nrow = 1)
    # turn sorted matrix into vector
    sorted_vector <- as.vector(t(MACSQuant@my_replicates_sorted))

    for (i in sorted_vector) {
        matched <- t(which(MACSQuant@my_data$WID == i))
        if (length(matched) != 2) {
                warning(paste("Your file do not contains 2 gates",
                    " for replicate: ",
                    i, "\nPlease be sure to only have",
                    "P1 and P1/P2 gates in your file",
                sep = ""
                ))
        }
        indice_matrix <- cbind(indice_matrix, matched)
    }
    indices <- indice_matrix[, -c(1)]
    ignored <- which(!(seq_len(dim(MACSQuant@my_data)[1]) %in% indices))
    ignored_print <- paste(unique(MACSQuant@my_data$WID[ignored]),
        collapse = ",")

    if (length(indices) != dim(MACSQuant@my_data)[1]) {
        warning(paste("!!! ",
                ignored_print,
                " not selected and will be ignored",
                sep = "", collapse = ""
        ))
    }
    if (MACSQuant@param.output$save.files == TRUE) {
        write.table(MACSQuant@my_data[indices, ],
                paste(MACSQuant@param.output$path,
                        "/outputMQ/sorted_table.txt", sep = ""),
                sep = "\t"
        )
        message("--> Done: New data table saved table in ./outputMQ")
    }
    message("--> Done: sorted data stored in variable my_data_sorted")

    return(indices)
}

#
# check_variables <- function() {
#     warn <- NULL
#     if (!exists("my_data_sorted")) {
#         warn <- paste("Variables 'my_data_sorted'",
#                 "missing: Please run order_data() first",
#                 sep = " "
#         )
#     }
#     if (!exists("my_replicates_sorted")) {
#         warn <- paste("Variables 'my_replicates_sorted'",
#                 "missing: Please run on_plate_selection() first",
#                 sep = " "
#         )
#     }
#     if (!(exists("my_data"))) {
#         warn <- paste("Variable 'my_data'",
#                 "missing: Please run load_maxQuant() first",
#                 sep = " "
#         )
#     }
#     return(warn)
# }

# Tests for functions in toolbox script
set.seed(42)

# load a minimal example data set (subset of nbt dataset)
filepath <- system.file("extdata", "drugs.xlsx",
    package = "MACSQuantifyR")
load_MACSQuant(filepath)

# Tests for output folder creation
# --------------------------------------------------------------------------------

MACSQuant <- load_MACSQuant(filepath)
MACSQuant@param.output$c_names <- c(paste("cond", rep(1:18), sep = " "))

context("path validity; create_output_folder()")
test_that("path exists", {
    expect_true(dir.exists(MACSQuant@param.output$path))
})

# Tests for GUI init
# --------------------------------------------------------------------------------

context("GUI format; init_GUI()")
well_letter=init_GUI()
test_that("GUI formated correclty", {
    expect_identical(well_letter,
                    c("H",
                     "G",
                     "F",
                     "E",
                     "D",
                     "C",
                     "B",
                     "A")
                )
})

# Tests for GUI interpretation
# --------------------------------------------------------------------------------
number_of_replicates <- 3
number_of_conditions <- 1
col <- rep(2, number_of_conditions)
point_matrix=list(x=c(2,2,2),y=c(7,6,5))
coordinates_names=to_well_names(point_matrix,col,well_letter)

context("GUI reading; to_well_names()")
test_that("GUI selection succeded", {
    expect_true(length(coordinates_names)==
                    number_of_replicates &
                is.null(dim(coordinates_names)))

    expect_true(length(unique(coordinates_names))==
                    number_of_replicates)

    expect_true((length(point_matrix) == 2 &
                     sum(point_matrix$y < 8.5) == 3 &
                     sum(point_matrix$y > 0.5) == 3 &
                     sum(point_matrix$y < 12.5) == 3 &
                     sum(point_matrix$x > 0.5) == 3))
})

# Tests for excel correspondance
# --------------------------------------------------------------------------------

matched <- match_id_line(MACSQuant, coordinates_names)
context("excel corresp; match_id_line()")
test_that("selected wells matched ", {
    expect_true(length(matched)==
                number_of_replicates*2)

    expect_true(sum(is.na(matched))==0)
    })


# Tests for statistical results
# --------------------------------------------------------------------------------
MACSQuant@param.experiment$number_of_replicates=3
MACSQuant@param.experiment$number_of_conditions=1

statistics <- data.frame(
    Full.path.first = NA,
    WID.first = NA,
    Fluo.percent.plus = NA,
    Fluo.percent.minus = NA,
    sd_percent = NA,
    Cell.count.minus = NA,
    sd_count = NA, stringsAsFactors = FALSE
)

statistics[1,]=compute_statistics(MACSQuant,
                   matched,
                   stats = "mean"
)

statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
    as.numeric(x)
}, numeric(number_of_conditions))


context("statistics computation; compute_statistics()")
test_that("statistics dataframe is processed correctly", {
    expect_true(dim(statistics)[2]==7)
    expect_true(is.character(statistics$Full.path.first))
    expect_true(is.character(statistics$WID.first))
    expect_true(is.numeric(statistics$Fluo.percent.plus))
    expect_true(is.numeric(statistics$Fluo.percent.minus))
    expect_true(is.numeric(statistics$sd_percent))
    expect_true(is.numeric(statistics$Cell.count.minus))
    expect_true(is.numeric(statistics$sd_count))
    })

test_that("statistics are rendered correctly", {
    expect_equal(statistics$Fluo.percent.plus,1,tolerance=.99)
    expect_equal(statistics$Fluo.percent.minus,1,tolerance=.99)
    expect_gt(statistics$sd_percent,0)
    expect_gt(statistics$sd_count,0)
    expect_gt(statistics$Cell.count.minus,0)
})

#' @export on_plate_selection
#' @importFrom graphics axis locator plot points text title legend par
#' @importFrom grDevices dev.copy dev.off png
#' @importFrom utils write.table
#' @importFrom stats median sd
#' @importFrom grDevices heat.colors
#' @importFrom methods new
#' @importFrom gridExtra grid.arrange
#'
#' @title Sort experimental design on graphical 96-well-plate
#' @description
#' Loads user's data, prompt a graphical representation of a 96
#' well plate and let the user select where the duplicates of each
#' condition were placed. Use for reordering excel file.
#' Plate image with selection can also be saved in the form of a png
#' file in the "specified_path/output_MQ" directory.

#' @name on_plate_selection
#' @rdname on_plate_selection
#' @aliases on_plate_selection
#' @usage
#' on_plate_selection(MACSQuant,number_of_replicates,number_of_conditions,
#' control=FALSE,save.files=FALSE)
#' @param MACSQuant object of class MACSQuant resulting of the function
#' load_maxQuant().
#' Contains the original data table
#' @param number_of_replicates For each condition, the number of duplicates
#' (must be the same for all conditions)
#' @param number_of_conditions The number of conditions tested
#' (eg: Drug 1 alone, Drug 2 alone)
#' @param control Is there a control in this experiment (eg: Staurosporin)
#' @param save.files Used to save the image in the output folder
#' @examples
#' print("run manually, requires user input")
#' # on_plate_selection(MACSQuant,3,5)
#' # let you select 5 conditions of 3 replicates each
#' @return A formatted report file along with intermediates results

#source("./R/function_toolbox.R")
# source("./R/barplot_data.R")


on_plate_selection <- function(MACSQuant,
                                number_of_replicates,
                                number_of_conditions,
                                control = FALSE,
                                save.files = FALSE) {

    # check if data is imported or not
    if (is.null(MACSQuant@my_data)) {
        stop(paste("Data missing: Please run load_MACSQuant or a",
            "new_class_MQ to create MACSQuant object", sep = " "))
    }

    # checking if arguments are correct
    if (!is.numeric(number_of_conditions) | !is.numeric(number_of_replicates)) {
        stop(paste("Both number_of_conditions and number_of_replicates",
            "must be numeric",
            sep = " "
        ))
    } else if (number_of_conditions <= 0 | number_of_replicates <= 0) {
        stop(paste("Both number_of_conditions and number_of_replicates",
            "must be positive",
            sep = " "
        ))
    } else {
        MACSQuant@param.experiment$number_of_replicates <- number_of_replicates
        MACSQuant@param.experiment$number_of_conditions <- number_of_conditions
    }

    # checking if plot options (xlabs) are present
    # and correctly formatted
    if (length(MACSQuant@param.experiment$c_names) == 0) {
        col <- rep(2, number_of_conditions)
    } else if (length(MACSQuant@param.experiment$c_names) ==
        number_of_conditions) {
        col <- heat.colors(length(MACSQuant@param.experiment$c_names))
    } else if (length(MACSQuant@param.experiment$c_names) !=
        number_of_conditions) {
        stop(paste("If you give a name to your conditions:",
            "all conditions except controls must be named",
            "(length(c_names)==number_of_conditions)\n",
            "else rm(c_names) to remove condition names",
            sep = " "
        ))
    }

    # starting messages
    message("...To quit press ESC...")
    message(paste("...You can now select your conditions replicates",
        "(without control condition replicates)...",
        sep = " "
    ))

    # GUI plate plot init
    well_letter <- init_GUI()

    # initialization of dataframes sorted matrix of replicates
    # and statistics
    sorted_matrix <- matrix(
        data = NA,
        ncol = number_of_replicates,
        nrow = number_of_conditions
    )
    statistics <- data.frame(
        Full.path.first = NA,
        WID.first = NA,
        Fluo.percent.plus = NA,
        Fluo.percent.minus = NA,
        sd_percent = NA,
        Cell.count.minus = NA,
        sd_count = NA, stringsAsFactors = FALSE
    )

    # converting xy plot selecction to well name
    message(paste("--> ", number_of_conditions, " conditions: ...", sep = ""))
    for (i in seq_len(number_of_conditions)) {
        # every condition compute statistics on replicates
        # locate replicates for condition i
        loc <- locator(type = "n", n = number_of_replicates)
        # ensure proper data selection within graph
        if (length(loc) == 2 & sum(loc$y < 8.5) == 3 & sum(loc$y > 0.5) == 3
        & sum(loc$y < 12.5) == 3 & sum(loc$x > 0.5) == 3) {
            sorted_matrix[i, ] <- to_well_names(loc, col[i], well_letter)
            if (length(unique(sorted_matrix[i,])) != number_of_replicates)
            {stop("Ambiguous selection, please run the function again")}
            matched <- match_id_line(MACSQuant, sorted_matrix[i, ])
            if (length(matched) != number_of_replicates * 2) {
                stop(c(
                    paste(
                        "Your file may not contains 2 gates",
                        "for one or more replicates in: ",
                        sep = " "
                    ),
                    paste(sorted_matrix[i, ], collapse = ","), "\nPlease",
                    "be sure to only have P1 and P1/P2 gates in your file"
                ))
            }
            statistics[i, ] <- compute_statistics(MACSQuant,
                matched,
                stats = "mean"
            )
            # print(statistics[i, ])
            message(paste(i, "...", sep = ""))
        } else {
            warning("Outside of selection field, select your data again")
            break
        }
    }
    message("OK\n")
    sorted_matrix_final <- sorted_matrix
    if (i != number_of_conditions) {
        stop("Process interrupted please start again")
    }
    message("\n--> Done: replicates identified")
    message("--> Done: statistics on each condition replicates")


    if (control == TRUE) {
        MACSQuant@param.experiment$control <- TRUE
        message("...You can now select your control replicates...")
        message("--> 1 control: ...")

        # check with users
        sorted_matrix_ctrl <- matrix(
            data = NA, ncol = number_of_replicates,
            nrow = 1
        )

        loc2 <- locator(type = "n", n = number_of_replicates)
        if (length(loc2) == 2) {
            sorted_matrix_ctrl[1, ] <- to_well_names(loc2, 1, well_letter)
            matched <- match_id_line(MACSQuant, sorted_matrix_ctrl[1, ])
            if (length(matched) != number_of_replicates * 2) {
                warning(c(
                    paste(
                        "Your file may not contains 2 gates",
                        "for one or more replicates in: ",
                        sep = " "
                    ),
                    paste(sorted_matrix_ctrl[1, ], collapse = ","),
                    "\nPlease",
                    "be sure to only have P1 and P1/P2 gates in your file"
                ))
            }
            statistics[i + 1, ] <- compute_statistics(MACSQuant, matched,
                stats = "mean"
            )
            message("OK...")

            # print(paste('selection',paste(sorted_matrix_ctrl[1,],collapse =
            # ','),sep=' '))
            message("\n--> Done: statistics on each control replicates")
            sorted_matrix_final <- rbind(sorted_matrix_final,
                sorted_matrix_ctrl)
            message(sorted_matrix_final)
        } else {
            stop("Outside of selection field, select your data again")

        }
    }
    MACSQuant@my_replicates_sorted <- sorted_matrix_final
    if (control == FALSE &
        (length(MACSQuant@param.experiment$c_names) == 0)) {
        legend("topright",
            inset = c(-0.3, 0.05), legend = c("Conditions"),
            pch = c(1), col = col[1])
        MACSQuant@param.output$plt.labels <- c(rep("Conditions",
            number_of_conditions))
        plt.labels <- c(rep("Conditions", number_of_conditions))
        statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
            as.numeric(x)
        }, numeric(number_of_conditions))
    } else if (control == TRUE &
        (length(MACSQuant@param.experiment$c_names) == 0)) {
        legend("topright", inset = c(-0.3, 0.05), legend = c(
            "Conditions",
            "Control"
        ), pch = c(1), col = c(col[1], 1))
        MACSQuant@param.output$plt.labels <- c(
            rep("Conditions",
                number_of_conditions), "Control")
        plt.labels <- c(rep("Conditions", number_of_conditions), "Control")
        statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
            as.numeric(x)
        }, numeric(number_of_conditions + 1))
    } else if (control == FALSE &
        (length(MACSQuant@param.experiment$c_names) != 0)) {
        legend("topright",
            inset = c(-0.3, 0.05), legend = MACSQuant@param.experiment$c_names,
            pch = c(1), col = col
        )
        MACSQuant@param.output$plt.labels <-
            rep(MACSQuant@param.experiment$c_names)
        plt.labels <- rep(MACSQuant@param.experiment$c_names)
        statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
            as.numeric(x)
        }, numeric(number_of_conditions))
    } else if (control == TRUE &
        (length(MACSQuant@param.experiment$c_names) != 0)) {
        legend("topright", inset = c(-0.3, 0.05), legend = c(
            MACSQuant@param.experiment$c_names,
            "Control"
        ), pch = c(1), col = c(col, 1))
        MACSQuant@param.output$plt.labels <-
            c(MACSQuant@param.experiment$c_names, "Control")
        plt.labels <- c(MACSQuant@param.experiment$c_names, "Control")
        statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
            as.numeric(x)
        }, numeric(number_of_conditions + 1))
    }


    if (save.files == TRUE) {
        MACSQuant@param.output$save.files <- TRUE
        MACSQuant <- create_output_folder(MACSQuant)
        dev.copy(png, paste(MACSQuant@param.output$path,
            "/outputMQ/plate_template.png", sep = ""),
        width = 600, height = 600,
        units = "px"
        )
        dev.off()
        message("--> Done: image saved")
        write.table(statistics, paste(MACSQuant@param.output$path,
            "/outputMQ/statistics.txt ", sep = ""),
        sep = "\t")
        message("--> Done: statistics table saved")
    }


    message("--> Done: replicates stored in variable my_replicates_sorted")
    MACSQuant@statistics <- statistics

    indices <- order_data(MACSQuant)
    MACSQuant@my_data_sorted <- MACSQuant@my_data[indices, ]

    if (MACSQuant@param.experiment$control == TRUE &
        length(MACSQuant@param.experiment$doses) != 0) {
        col <- c(col, 1)
    }  else if (MACSQuant@param.experiment$control == TRUE &
        length(MACSQuant@param.experiment$doses) == 0) {
        MACSQuant@param.experiment$doses <- seq_len(number_of_conditions + 1)
        col <- c(col, 1)
    } else if (MACSQuant@param.experiment$control == FALSE &
        length(MACSQuant@param.experiment$doses) == 0) {
        MACSQuant@param.experiment$doses <- seq_len(number_of_conditions)
    }

    MACSQuant@param.output$plt.col <- col
    if (length(MACSQuant@param.experiment$doses.alt) == 0) {
        for (flav in c("counts", "percent"))
        {
            p <- barplot_data(MACSQuant, col, plt.flavour = flav,
                plt.labels = plt.labels, plt.combo = FALSE)
            grid.arrange(p)
            if (save.files == TRUE) {
                ggsave(paste(MACSQuant@param.output$path,
                    "/outputMQ/barplot_", flav, "_pipeline.png", sep = ""),
                width = 15.875, height = 15.875,
                units = "cm", p)
                message("--> Done: image saved")
            }
        }

    } else {
        message("...You can now run barplot_data(...plt.combo = TRUE)...")
    }
    return(MACSQuant)
}




on_plate_selection.internal <- function(MACSQuant,
                               number_of_replicates,
                               number_of_conditions,
                               control = FALSE,
                               save.files = FALSE) {

  # check if data is imported or not
  if (is.null(MACSQuant@my_data)) {
    stop(paste("Data missing: Please run load_MACSQuant or a",
               "new_class_MQ to create MACSQuant object", sep = " "))
  }

  # checking if arguments are correct
  if (!is.numeric(number_of_conditions) | !is.numeric(number_of_replicates)) {
    stop(paste("Both number_of_conditions and number_of_replicates",
               "must be numeric",
               sep = " "
    ))
  } else if (number_of_conditions <= 0 | number_of_replicates <= 0) {
    stop(paste("Both number_of_conditions and number_of_replicates",
               "must be positive",
               sep = " "
    ))
  } else {
    MACSQuant@param.experiment$number_of_replicates <- number_of_replicates
    MACSQuant@param.experiment$number_of_conditions <- number_of_conditions
  }

  # checking if plot options (xlabs) are present
  # and correctly formatted
  if (length(MACSQuant@param.experiment$c_names) == 0) {
    col <- rep(2, number_of_conditions)
  } else if (length(MACSQuant@param.experiment$c_names) ==
             number_of_conditions) {
    col <- heat.colors(length(MACSQuant@param.experiment$c_names))
  } else if (length(MACSQuant@param.experiment$c_names) !=
             number_of_conditions) {
    stop(paste("If you give a name to your conditions:",
               "all conditions except controls must be named",
               "(length(c_names)==number_of_conditions)\n",
               "else rm(c_names) to remove condition names",
               sep = " "
    ))
  }

  # starting messages
  message("...To quit press ESC...")
  message(paste("...You can now select your conditions replicates",
                "(without control condition replicates)...",
                sep = " "
  ))

  # GUI plate plot init
  well_letter <- init_GUI()

  # initialization of dataframes sorted matrix of replicates
  # and statistics
  sorted_matrix <- matrix(
    data = NA,
    ncol = number_of_replicates,
    nrow = number_of_conditions
  )
  statistics <- data.frame(
    Full.path.first = NA,
    WID.first = NA,
    Fluo.percent.plus = NA,
    Fluo.percent.minus = NA,
    sd_percent = NA,
    Cell.count.minus = NA,
    sd_count = NA, stringsAsFactors = FALSE
  )

  # converting xy plot selecction to well name
  message(paste("--> ", number_of_conditions, " conditions: ...", sep = ""))
  for (i in seq_len(number_of_conditions)) {
    # every condition compute statistics on replicates
    # locate replicates for condition i
    loc <- locator(type = "n", n = number_of_replicates)
    # ensure proper data selection within graph
    if (length(loc) == 2 & sum(loc$y < 8.5) == 3 & sum(loc$y > 0.5) == 3
        & sum(loc$y < 12.5) == 3 & sum(loc$x > 0.5) == 3) {
      sorted_matrix[i, ] <- to_well_names(loc, col[i], well_letter)
      if (length(unique(sorted_matrix[i,])) != number_of_replicates)
      {stop("Ambiguous selection, please run the function again")}
      matched <- match_id_line(MACSQuant, sorted_matrix[i, ])
      if (length(matched) != number_of_replicates * 2) {
        stop(c(
          paste(
            "Your file may not contains 2 gates",
            "for one or more replicates in: ",
            sep = " "
          ),
          paste(sorted_matrix[i, ], collapse = ","), "\nPlease",
          "be sure to only have P1 and P1/P2 gates in your file"
        ))
      }
      statistics[i, ] <- compute_statistics(MACSQuant,
                                            matched,
                                            stats = "mean"
      )
      # print(statistics[i, ])
      message(paste(i, "...", sep = ""))
    } else {
      warning("Outside of selection field, select your data again")
      break
    }
  }
  message("OK\n")
  sorted_matrix_final <- sorted_matrix
  if (i != number_of_conditions) {
    stop("Process interrupted please start again")
  }
  message("\n--> Done: replicates identified")
  message("--> Done: statistics on each condition replicates")


  if (control == TRUE) {
    MACSQuant@param.experiment$control <- TRUE
    message("...You can now select your control replicates...")
    message("--> 1 control: ...")

    # check with users
    sorted_matrix_ctrl <- matrix(
      data = NA, ncol = number_of_replicates,
      nrow = 1
    )

    loc2 <- locator(type = "n", n = number_of_replicates)
    if (length(loc2) == 2) {
      sorted_matrix_ctrl[1, ] <- to_well_names(loc2, 1, well_letter)
      matched <- match_id_line(MACSQuant, sorted_matrix_ctrl[1, ])
      if (length(matched) != number_of_replicates * 2) {
        warning(c(
          paste(
            "Your file may not contains 2 gates",
            "for one or more replicates in: ",
            sep = " "
          ),
          paste(sorted_matrix_ctrl[1, ], collapse = ","),
          "\nPlease",
          "be sure to only have P1 and P1/P2 gates in your file"
        ))
      }
      statistics[i + 1, ] <- compute_statistics(MACSQuant, matched,
                                                stats = "mean"
      )
      message("OK...")

      # print(paste('selection',paste(sorted_matrix_ctrl[1,],collapse =
      # ','),sep=' '))
      message("\n--> Done: statistics on each control replicates")
      sorted_matrix_final <- rbind(sorted_matrix_final,
                                   sorted_matrix_ctrl)
      message(sorted_matrix_final)
    } else {
      stop("Outside of selection field, select your data again")

    }
  }
  MACSQuant@my_replicates_sorted <- sorted_matrix_final
  if (control == FALSE &
      (length(MACSQuant@param.experiment$c_names) == 0)) {
    legend("topright",
           inset = c(-0.3, 0.05), legend = c("Conditions"),
           pch = c(1), col = col[1])
    MACSQuant@param.output$plt.labels <- c(rep("Conditions",
                                               number_of_conditions))
    plt.labels <- c(rep("Conditions", number_of_conditions))
    statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
      as.numeric(x)
    }, numeric(number_of_conditions))
  } else if (control == TRUE &
             (length(MACSQuant@param.experiment$c_names) == 0)) {
    legend("topright", inset = c(-0.3, 0.05), legend = c(
      "Conditions",
      "Control"
    ), pch = c(1), col = c(col[1], 1))
    MACSQuant@param.output$plt.labels <- c(
      rep("Conditions",
          number_of_conditions), "Control")
    plt.labels <- c(rep("Conditions", number_of_conditions), "Control")
    statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
      as.numeric(x)
    }, numeric(number_of_conditions + 1))
  } else if (control == FALSE &
             (length(MACSQuant@param.experiment$c_names) != 0)) {
    legend("topright",
           inset = c(-0.3, 0.05), legend = MACSQuant@param.experiment$c_names,
           pch = c(1), col = col
    )
    MACSQuant@param.output$plt.labels <-
      rep(MACSQuant@param.experiment$c_names)
    plt.labels <- rep(MACSQuant@param.experiment$c_names)
    statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
      as.numeric(x)
    }, numeric(number_of_conditions))
  } else if (control == TRUE &
             (length(MACSQuant@param.experiment$c_names) != 0)) {
    legend("topright", inset = c(-0.3, 0.05), legend = c(
      MACSQuant@param.experiment$c_names,
      "Control"
    ), pch = c(1), col = c(col, 1))
    MACSQuant@param.output$plt.labels <-
      c(MACSQuant@param.experiment$c_names, "Control")
    plt.labels <- c(MACSQuant@param.experiment$c_names, "Control")
    statistics[, seq(3, 7)] <- vapply(statistics[, seq(3, 7)], function(x) {
      as.numeric(x)
    }, numeric(number_of_conditions + 1))
  }


  if (save.files == TRUE) {
    MACSQuant@param.output$save.files <- TRUE
    MACSQuant <- create_output_folder(MACSQuant)
    dev.copy(png, paste(MACSQuant@param.output$path,
                        "/outputMQ/plate_template.png", sep = ""),
             width = 600, height = 600,
             units = "px"
    )
    dev.off()
    message("--> Done: image saved")
    write.table(statistics, paste(MACSQuant@param.output$path,
                                  "/outputMQ/statistics.txt ", sep = ""),
                sep = "\t")
    message("--> Done: statistics table saved")
  }


  message("--> Done: replicates stored in variable my_replicates_sorted")
  MACSQuant@statistics <- statistics

  indices <- order_data(MACSQuant)
  MACSQuant@my_data_sorted <- MACSQuant@my_data[indices, ]

  if (MACSQuant@param.experiment$control == TRUE &
      length(MACSQuant@param.experiment$doses) != 0) {
    col <- c(col, 1)
  }  else if (MACSQuant@param.experiment$control == TRUE &
              length(MACSQuant@param.experiment$doses) == 0) {
    MACSQuant@param.experiment$doses <- seq_len(number_of_conditions + 1)
    col <- c(col, 1)
  } else if (MACSQuant@param.experiment$control == FALSE &
             length(MACSQuant@param.experiment$doses) == 0) {
    MACSQuant@param.experiment$doses <- seq_len(number_of_conditions)
  }

  MACSQuant@param.output$plt.col <- col
  if (length(MACSQuant@param.experiment$doses.alt) == 0) {
    for (flav in c("counts", "percent"))
    {
      p <- barplot_data(MACSQuant, col, plt.flavour = flav,
                        plt.labels = plt.labels, plt.combo = FALSE)
      grid.arrange(p)
      if (save.files == TRUE) {
        ggsave(paste(MACSQuant@param.output$path,
                     "/outputMQ/barplot_", flav, "_pipeline.png", sep = ""),
               width = 15.875, height = 15.875,
               units = "cm", p)
        message("--> Done: image saved")
      }
    }

  } else {
    message("...You can now run barplot_data(...plt.combo = TRUE)...")
  }
  return(MACSQuant)
}

#' @export barplot_data
#' @importFrom ggplot2 aes element_text geom_bar
#' geom_errorbar ggplot ggtitle position_dodge
#' scale_fill_manual theme theme_minimal xlab ylab
#' ggsave facet_grid labs unit element_blank
#' @importFrom lattice cloud
#' @importFrom latticeExtra panel.3dbars
#'
#' @title Generate barplots
#' @description
#' Uses the informations stored in the statistic tables of
#' the MACSQuant object to generate barplots for the specified
#' conditions. Plots can also be saved in the form of a png
#' file in the output_MQ directory.

#' @name barplot_data
#' @rdname barplot_data
#' @aliases barplot_data
#' @usage
#' barplot_data(MACSQuant,plt.col=NULL,plt.conditions=NULL, plt.flavour=NULL,
#' plt.labels = NULL, plt.combo=FALSE,plt.3D.only = NULL,...)
#' @param MACSQuant object of class MACSQuant resulting of the function
#' load_maxQuant().
#' Contains the original data table
#' @param plt.col In case of manual run is used to define the bar colors.
#' (must be the same for all conditions)
#' @param plt.conditions user defined vector of conditions to plot
#' (example: plt.conditions=c(1:9))
#' @param plt.flavour Which barplot to produce, cell count or percentage of
#' fluorochrome
#' (i.e: "counts","percent")
#' @param plt.labels xlabels of the plot
#' @param plt.combo Does the experiment involves multiple variables
#' (i.e some condition are a drug combination screening)
#' @param plt.3D.only Whether to plot 3D barplot alone
#' @param ... params for lattice cloud namely z and x for parameter screen
#' default for z and x are c(-110,-70) and argument xlab and ylab
#' @examples
#' drugs_R_image <- system.file("extdata",
#'     "drugs.RDS",
#'     package = "MACSQuantifyR")
#' MACSQuant <- readRDS(drugs_R_image)
#' flavour <- "counts"
#' number_of_conditions <-
#'     slot(MACSQuant, "param.experiment")$number_of_conditions
#' plt.col <- c(rep(2, number_of_conditions), 1)
#' barplot_data(MACSQuant,
#'     plt.col = plt.col,
#'     plt.conditions = NULL,
#'     plt.flavour = flavour,
#'     plt.labels = NULL,
#'     plt.combo = FALSE)
#' @return returns a barplot of the data
#'
barplot_data <- function(MACSQuant,
                        plt.col = NULL,
                        plt.conditions = NULL,
                        plt.flavour = NULL,
                        plt.labels = NULL,
                        plt.combo = FALSE,
                        plt.3D.only = NULL,
                        ...) {
    if (!is.null(plt.3D.only) & !is.logical(plt.3D.only))
    {
        stop("plt.3D.only: logical argument expected")
    }

    l <- list(...)
    e <- new.env()
    if (length(l) > 0) {
        for (i in seq_len(length(l)))
        {
            assign(names(l)[[i]], l[[i]], envir = e)
        }
    }

    if (!"z" %in% names(e)) {
        e$z <- -110
    }
    if (!"x" %in% names(e)) {
        e$x <- -70
    }
    if (!"xlab" %in% names(e)) {
        e$xlab <- "Drug1"
    }
    if (!"ylab" %in% names(e)) {
        e$ylab <- "Drug2"
    }
    # check wich labels to apply to the plot
    # label exists not defined
    if (length(MACSQuant@param.output$plt.labels) > 0 &
        is.null(plt.labels)) {
        plt.labels <- MACSQuant@param.output$plt.labels
        # labels not diffined
    } else if (length(MACSQuant@param.output$plt.labels) == 0 &
        is.null(plt.labels)) {
        stop(paste("specify a character vector plt.labels",
            "OR define labels in MACSQuant@param.output$plt.labels",
            sep = " "))
    }

    # which plot to compute count or percent
    # check if arguments are correct
    if (is.null(plt.flavour)) {
        stop(paste("Argument plt.flavour incorrect",
            "please choose between 'counts' and 'percent'", sep = " "))
    } else if (plt.flavour != "counts" & plt.flavour != "percent") {
        stop(paste("Argument plt.flavour incorrect",
            "please choose between 'counts' and 'percent'", sep = " "))
        # apply choice to local environement variables
    } else if (plt.flavour == "counts") {
        plt.y <- MACSQuant@statistics$Cell.count.minus
        plt.y.sd <- MACSQuant@statistics$sd_count
        plt.y.lab <- "Cell count"
        plt.title <- "Barplot cell count"
    } else {
        plt.y <- MACSQuant@statistics$Fluo.percent.minus
        plt.y.sd <- MACSQuant@statistics$sd_percent
        plt.y.lab <- "Percent fluo minus"
        plt.title <- "Barplot percentage"
    }
    # check if title is defined in MACSQuant object
    if (length(MACSQuant@param.output$plt.title) != 0) {
        plt.title <- MACSQuant@param.output$plt.title
    }

    # subset conditions in case of user specification
    # apply to local env variables
    if (!is.null(plt.conditions)) {
        if (length(plt.col) != length(plt.conditions)) {
            warning(paste("Number of condition selected doesn't",
                "match length(plt.color)", sep = " "))
            plt.col <- heat.colors(length(plt.conditions))
        }
        plt.statistics <- MACSQuant@statistics[plt.conditions, ]
        plt.y <- plt.y[plt.conditions]
        plt.y.sd <- plt.y.sd[plt.conditions]
    } else {
        plt.statistics <- MACSQuant@statistics
    }

    # define plot variables
    plt.doses <- factor(MACSQuant@param.experiment$doses)
    plt.labels <- factor(plt.labels, levels = c(unique(plt.labels)))
    plt.condition <- factor(plt.col, levels = c(unique(plt.col)))

    # prepare ggplot data.f
    if (plt.combo == FALSE & is.null(plt.3D.only)) {

        data.f <- cbind(plt.statistics, plt.doses)
        p <- ggplot(data.f, aes(x = plt.doses, y = plt.y)) +

            geom_bar(position = position_dodge(), stat = "identity",
                colour = "black", size = 0.1, aes(fill = plt.labels),
                alpha = .7) +

            geom_errorbar(aes(ymin = plt.y - plt.y.sd, ymax = plt.y + plt.y.sd),
                size = 0.3, width = 0.2, position = position_dodge(0.9)) +

            xlab("Dose") + ylab(plt.y.lab) +

            scale_fill_manual(
                values = as.character(unique(plt.condition)),
                name = "Conditions",
                labels = unique(plt.labels)
            ) +

            ggtitle(plt.title) +
            theme_minimal() +
            theme(axis.title.x = element_text(
                face = "bold", colour = "#990000", size = 15),
            axis.title.y = element_text(
                face = "bold", colour = "#990000", size = 15),
            axis.text.x = element_text(size = 12),
            axis.text.y = element_text(size = 12))
        #     angle = 45,
        #     vjust = 0.5,
    } else if (plt.combo == TRUE & is.null(plt.3D.only)) {
        plt.doses.alt <- factor(MACSQuant@param.experiment$doses.alt)
        plt.doses <- factor(MACSQuant@param.experiment$doses)
        if (MACSQuant@param.experiment$control) {
            plt.statistics <- plt.statistics[-nrow(plt.statistics), ]
            plt.y <- plt.y[-length(plt.y)]
        }
        plt.labels <- factor(plt.labels[-length(plt.labels)])
        plt.title <- plt.title

        data.f <- cbind(plt.statistics, plt.doses, plt.doses.alt)
        p1 <- ggplot(data.f, aes(x = plt.doses, y = plt.y)) +
            geom_bar(position = position_dodge(), stat = "identity",
                colour = "black",
                size = 0.1, aes(fill = plt.labels), alpha = .7) +
            facet_grid(. ~ plt.doses.alt, space = "free_x", scales = "free_x",
                switch = "x") +

            labs(x = "") + theme(panel.spacing = unit(0, "lines"),
                strip.background = element_blank(),
                strip.placement = "outside") +
            scale_fill_manual(
                values = heat.colors(dim(plt.statistics)[1]),
                name = "Conditions" # ,
                # labels = unique(plt.labels)
            ) +
            xlab("Dose") + ylab(plt.y.lab) +
            ggtitle(plt.title) +
            theme_minimal() +
            theme(axis.title.x = element_text(
                face = "bold", colour = "#990000", size = 15),
            axis.title.y = element_text(
                face = "bold", colour = "#990000", size = 15),
            axis.text.x = element_text(size = 12, angle = 45, vjust = 0.5),
            axis.text.y = element_text(size = 12)
            )


        p2 <- cloud((plt.y ~ data.f$plt.doses + plt.doses.alt),
            data.f, panel.3d.cloud = panel.3dbars,
            col.facet =  plt.col, xbase = .8, ybase = .3,
            scales = list(arrows = FALSE, col = 1,
                distance = 1),
            screen = list(z = e$z, x = e$x),
            par.settings = list(box.3d = list(col = NA)),
            xlab = e$xlab, ylab = e$ylab, zlab = plt.flavour)


        p <- gridExtra::arrangeGrob(p1, p2, ncol = 2)

    } else {
        plt.doses.alt <- factor(MACSQuant@param.experiment$doses.alt)
        plt.doses <- factor(MACSQuant@param.experiment$doses)
        if (MACSQuant@param.experiment$control) {
            plt.statistics <- plt.statistics[-nrow(plt.statistics), ]
            plt.y <- plt.y[-length(plt.y)]
        }
        data.f <- cbind(plt.statistics, plt.doses, plt.doses.alt)
        p <- cloud((plt.y ~ data.f$plt.doses + plt.doses.alt),
            data.f, panel.3d.cloud = panel.3dbars,
            col.facet =  plt.col, xbase = .8, ybase = .3,
            scales = list(arrows = FALSE, col = 1,
                distance = 1),
            screen = list(z = e$z, x = e$x),
            par.settings = list(box.3d = list(col = NA)),
            xlab = e$xlab, ylab = e$ylab, zlab = plt.flavour)
    }

    return(p)
}

barplot_data.internal <- function(MACSQuant,
                         plt.col = NULL,
                         plt.conditions = NULL,
                         plt.flavour = NULL,
                         plt.labels = NULL,
                         plt.combo = FALSE,
                         plt.3D.only = NULL,
                         ...) {
    if (!is.null(plt.3D.only) & !is.logical(plt.3D.only))
    {
      stop("plt.3D.only: logical argument expected")
    }

    l <- list(...)
    e <- new.env()
    if (length(l) > 0) {
      for (i in seq_len(length(l)))
      {
        assign(names(l)[[i]], l[[i]], envir = e)
      }
    }

    if (!"z" %in% names(e)) {
      e$z <- -110
    }
    if (!"x" %in% names(e)) {
      e$x <- -70
    }
    if (!"xlab" %in% names(e)) {
      e$xlab <- "Drug1"
    }
    if (!"ylab" %in% names(e)) {
      e$ylab <- "Drug2"
    }
    # check wich labels to apply to the plot
    # label exists not defined
    if (length(MACSQuant@param.output$plt.labels) > 0 &
        is.null(plt.labels)) {
      plt.labels <- MACSQuant@param.output$plt.labels
      # labels not diffined
    } else if (length(MACSQuant@param.output$plt.labels) == 0 &
               is.null(plt.labels)) {
      stop(paste("specify a character vector plt.labels",
                 "OR define labels in MACSQuant@param.output$plt.labels",
                 sep = " "))
    }

    # which plot to compute count or percent
    # check if arguments are correct
    if (is.null(plt.flavour)) {
      stop(paste("Argument plt.flavour incorrect",
                 "please choose between 'counts' and 'percent'", sep = " "))
    } else if (plt.flavour != "counts" & plt.flavour != "percent") {
      stop(paste("Argument plt.flavour incorrect",
                 "please choose between 'counts' and 'percent'", sep = " "))
      # apply choice to local environement variables
    } else if (plt.flavour == "counts") {
      plt.y <- MACSQuant@statistics$Cell.count.minus
      plt.y.sd <- MACSQuant@statistics$sd_count
      plt.y.lab <- "Cell count"
      plt.title <- "Barplot cell count"
    } else {
      plt.y <- MACSQuant@statistics$Fluo.percent.minus
      plt.y.sd <- MACSQuant@statistics$sd_percent
      plt.y.lab <- "Percent fluo minus"
      plt.title <- "Barplot percentage"
    }
    # check if title is defined in MACSQuant object
    if (length(MACSQuant@param.output$plt.title) != 0) {
      plt.title <- MACSQuant@param.output$plt.title
    }

    # subset conditions in case of user specification
    # apply to local env variables
    if (!is.null(plt.conditions)) {
      if (length(plt.col) != length(plt.conditions)) {
        warning(paste("Number of condition selected doesn't",
                      "match length(plt.color)", sep = " "))
        plt.col <- heat.colors(length(plt.conditions))
      }
      plt.statistics <- MACSQuant@statistics[plt.conditions, ]
      plt.y <- plt.y[plt.conditions]
      plt.y.sd <- plt.y.sd[plt.conditions]
    } else {
      plt.statistics <- MACSQuant@statistics
    }

    # define plot variables
    plt.doses <- factor(MACSQuant@param.experiment$doses)
    plt.labels <- factor(plt.labels, levels = c(unique(plt.labels)))
    plt.condition <- factor(plt.col, levels = c(unique(plt.col)))

    # prepare ggplot data.f
    if (plt.combo == FALSE & is.null(plt.3D.only)) {

      data.f <- cbind(plt.statistics, plt.doses)
      p <- ggplot(data.f, aes(x = plt.doses, y = plt.y)) +

        geom_bar(position = position_dodge(), stat = "identity",
                 colour = "black", size = 0.1, aes(fill = plt.labels),
                 alpha = .7) +

        geom_errorbar(aes(ymin = plt.y - plt.y.sd, ymax = plt.y + plt.y.sd),
                      size = 0.3, width = 0.2, position = position_dodge(0.9)) +

        xlab("Dose") + ylab(plt.y.lab) +

        scale_fill_manual(
          values = as.character(unique(plt.condition)),
          name = "Conditions",
          labels = unique(plt.labels)
        ) +

        ggtitle(plt.title) +
        theme_minimal() +
        theme(axis.title.x = element_text(
          face = "bold", colour = "#990000", size = 15),
          axis.title.y = element_text(
            face = "bold", colour = "#990000", size = 15),
          axis.text.x = element_text(size = 12),
          axis.text.y = element_text(size = 12))
      #     angle = 45,
      #     vjust = 0.5,
    } else if (plt.combo == TRUE & is.null(plt.3D.only)) {
      plt.doses.alt <- factor(MACSQuant@param.experiment$doses.alt)
      plt.doses <- factor(MACSQuant@param.experiment$doses)
      if (MACSQuant@param.experiment$control) {
        plt.statistics <- plt.statistics[-nrow(plt.statistics), ]
        plt.y <- plt.y[-length(plt.y)]
      }
      plt.labels <- factor(plt.labels[-length(plt.labels)])
      plt.title <- plt.title

      data.f <- cbind(plt.statistics, plt.doses, plt.doses.alt)
      p1 <- ggplot(data.f, aes(x = plt.doses, y = plt.y)) +
        geom_bar(position = position_dodge(), stat = "identity",
                 colour = "black",
                 size = 0.1, aes(fill = plt.labels), alpha = .7) +
        facet_grid(. ~ plt.doses.alt, space = "free_x", scales = "free_x",
                   switch = "x") +

        labs(x = "") + theme(panel.spacing = unit(0, "lines"),
                             strip.background = element_blank(),
                             strip.placement = "outside") +
        scale_fill_manual(
          values = heat.colors(dim(plt.statistics)[1]),
          name = "Conditions" # ,
          # labels = unique(plt.labels)
        ) +
        xlab("Dose") + ylab(plt.y.lab) +
        ggtitle(plt.title) +
        theme_minimal() +
        theme(axis.title.x = element_text(
          face = "bold", colour = "#990000", size = 15),
          axis.title.y = element_text(
            face = "bold", colour = "#990000", size = 15),
          axis.text.x = element_text(size = 12, angle = 45, vjust = 0.5),
          axis.text.y = element_text(size = 12)
        )


      p2 <- cloud((plt.y ~ data.f$plt.doses + plt.doses.alt),
                  data.f, panel.3d.cloud = panel.3dbars,
                  col.facet =  plt.col, xbase = .8, ybase = .3,
                  scales = list(arrows = FALSE, col = 1,
                                distance = 1),
                  screen = list(z = e$z, x = e$x),
                  par.settings = list(box.3d = list(col = NA)),
                  xlab = e$xlab, ylab = e$ylab, zlab = plt.flavour)


      p <- gridExtra::arrangeGrob(p1, p2, ncol = 2)

    } else {
      plt.doses.alt <- factor(MACSQuant@param.experiment$doses.alt)
      plt.doses <- factor(MACSQuant@param.experiment$doses)
      if (MACSQuant@param.experiment$control) {
        plt.statistics <- plt.statistics[-nrow(plt.statistics), ]
        plt.y <- plt.y[-length(plt.y)]
      }
      data.f <- cbind(plt.statistics, plt.doses, plt.doses.alt)
      p <- cloud((plt.y ~ data.f$plt.doses + plt.doses.alt),
                 data.f, panel.3d.cloud = panel.3dbars,
                 col.facet =  plt.col, xbase = .8, ybase = .3,
                 scales = list(arrows = FALSE, col = 1,
                               distance = 1),
                 screen = list(z = e$z, x = e$x),
                 par.settings = list(box.3d = list(col = NA)),
                 xlab = e$xlab, ylab = e$ylab, zlab = plt.flavour)
    }

    return(p)
}

# Tests for output folder creation
# --------------------------------------------------------------------------------
filepath <- system.file("extdata", "drugs.RDS",
                        package = "MACSQuantifyR")
MACSQuant=readRDS(filepath)

plt.col = NULL
plt.conditions = NULL
plt.flavour = 'counts'
plt.labels = NULL
plt.combo = FALSE
plt.3D.only = NULL

plt.labels=MACSQuant@param.output$plt.labels
plt.col=MACSQuant@param.output$plt.col

context("argument validity; barplot_data()")
test_that("arguments are correctly specified", {
  expect_true(is.numeric(plt.col)|is.character(plt.col))
  expect_true(plt.flavour%in%c('percent','counts'))
  expect_true(is.numeric(plt.labels)|is.character(plt.labels))
  expect_is(plt.combo,"logical")
  expect_true(is.null(plt.3D.only)|is.logical(plt.3D.only))
 expect_identical(length(plt.col),length(plt.labels))
})




context("argument validity, plot.combo is true; barplot_data()")

filepath <- system.file("extdata", "drugs.Rdata",
                        package = "MACSQuantifyR")
load(filepath)
plt.combo = TRUE
plt.col <-
  c(
    heat.colors(length(slot(MACSQuant, "param.experiment")$c_names)), 1)

plt.labels <- c(slot(MACSQuant, "param.experiment")$c_names, "Control")
number_of_conditions=slot(MACSQuant, "param.experiment")$number_of_conditions

test_that("arguments are correctly specified", {
  expect_true(length(plt.labels)==number_of_conditions+1)
  expect_true(length(plt.col)==number_of_conditions+1)
  
})

create_output_folder <- function(MACSQuant) {
  # Create folder containing various output files
  # and variables
  
  if (length(MACSQuant@param.output$path) > 0) {
    if (!dir.exists(MACSQuant@param.output$path))
    {stop("Provided path does not exists, please sepecify a valid path")}
    path <- paste(MACSQuant@param.output$path, "/outputMQ", sep = "")
  } else {
    path <- "./outputMQ"
  }
  if (!dir.exists(file.path(path))) {
    dir.create(file.path(path))
    message("--> Done: Folder ./outputMQ created")
  }
  return(MACSQuant)
}

init_GUI <- function()
  # intialize GUI plate plot for user to select replicates on
{
  well_letter <- sort(toupper(letters[seq_len(8)]), decreasing = TRUE)
  df <- data.frame(df2 = seq_len(12), df1 = c(
    rep(1, 12), rep(2, 12),
    rep(3, 12), rep(4, 12), rep(5, 12), rep(6, 12), rep(7, 12), rep(
      8,
      12
    )
  ))
  rownames(df) <- vapply(toupper(letters[seq(8, 1)]), function(x) {
    paste(x, seq(12:1), sep = "")
  }, character(12))
  # TODO external X11()
  par(mar = c(3.1, 3.1, 3.1, 9), xpd = TRUE)
  plot(df,
       yaxt = "n", xaxt = "n", xlab = "", ylab = "", axes = FALSE,
       ylim = c(-0.49, 8.49), lwd = 3, pch = 21, cex = 4.5, col = "lightblue"
  )
  title("Well plate")
  axis(2, at = seq_len(8), labels = well_letter, las = 2, line = "1")
  axis(1, at = seq_len(12), labels = seq_len(12), line = "-2.5")
  text(df, labels = rownames(df), cex = 0.8, font = 1)
  return(well_letter)
}

to_well_names <- function(point_matrix, col, well_letter) {
  # interprete locations plot and return vector containing
  # the replicates names
  coordinates_raw <- unlist(point_matrix)
  coordinates_mat <- matrix(coordinates_raw, ncol = 2)
  coordinates_mat <- round(coordinates_mat)
  points(coordinates_mat, lwd = 1, pch = 21, cex = 3.2, col = col)
  coordinates_mat[, 2] <- well_letter[coordinates_mat[, 2]]
  coordinates_names <- paste(coordinates_mat[, 2], coordinates_mat[, 1],
                             sep = ""
  )
  return(coordinates_names)
}

match_id_line <- function(MACSQuant, wid_vector) {
  # match replicate id in raw data table (my_data)
  # returns indices in raw data
  matched <- c()
  for (j in wid_vector) {
    matched <- c(matched, which(MACSQuant@my_data$WID == j))
  }
  return(matched)
}

compute_statistics <- function(MACSQuant,
                               lines,
                               stats = "mean") {
  data_selected <- MACSQuant@my_data[lines, ]
  Counts <- c()
  Percent <- c()
  for (rep in seq(1, MACSQuant@param.experiment$number_of_replicates * 2,
                  2)) {
    Counts <- c(
      Counts,
      data_selected$`Count/mL`[rep] -
        data_selected$`Count/mL`[rep + 1]
    )
    Percent <- c(Percent, (data_selected$`%-#`[rep + 1]) / 100)
  }
  Full.path.first <- unlist(strsplit(
    data_selected$`Full path`[1],
    "\\\\P1"
  ))
  WID.first <- sort(data_selected$WID)[1]
  
  if (stats == "mean") {
    Count.minus <- mean(Counts)
    Percent.plus <- mean(Percent)
  } else if (stats == "median") {
    Count.minus <- median(Counts)
    Percent.plus <- median(Percent)
  } else {
    stop(paste("Values for argument stats",
               "should be c('mean','median'). Other not supported",
               sep = " "
    ))
  }
  sd_count <- sd(Counts)
  Percent.minus <- 1 - Percent.plus
  sd_percent <- sd(Percent)
  
  results <- c(
    Full.path.first, WID.first, Percent.plus, Percent.minus,
    sd_percent, Count.minus, sd_count
  )
  return(results)
}



order_data <- function(MACSQuant) {
  
  # is_variable_missing=(check_variables()) if
  # (length(is_variable_missing)>0){stop(is_variable_missing)}
  
  # pre allocate indice matrix
  indice_matrix <- matrix(nrow = 1)
  # turn sorted matrix into vector
  sorted_vector <- as.vector(t(MACSQuant@my_replicates_sorted))
  
  for (i in sorted_vector) {
    matched <- t(which(MACSQuant@my_data$WID == i))
    if (length(matched) != 2) {
      warning(paste("Your file do not contains 2 gates",
                    " for replicate: ",
                    i, "\nPlease be sure to only have",
                    "P1 and P1/P2 gates in your file",
                    sep = ""
      ))
    }
    indice_matrix <- cbind(indice_matrix, matched)
  }
  indices <- indice_matrix[, -c(1)]
  ignored <- which(!(seq_len(dim(MACSQuant@my_data)[1]) %in% indices))
  ignored_print <- paste(unique(MACSQuant@my_data$WID[ignored]),
                         collapse = ",")
  
  if (length(indices) != dim(MACSQuant@my_data)[1]) {
    warning(paste("!!! ",
                  ignored_print,
                  " not selected and will be ignored",
                  sep = "", collapse = ""
    ))
  }
  if (MACSQuant@param.output$save.files == TRUE) {
    write.table(MACSQuant@my_data[indices, ],
                paste(MACSQuant@param.output$path,
                      "/outputMQ/sorted_table.txt", sep = ""),
                sep = "\t"
    )
    message("--> Done: New data table saved table in ./outputMQ")
  }
  message("--> Done: sorted data stored in variable my_data_sorted")
  
  return(indices)
}

#
# check_variables <- function() {
#     warn <- NULL
#     if (!exists("my_data_sorted")) {
#         warn <- paste("Variables 'my_data_sorted'",
#                 "missing: Please run order_data() first",
#                 sep = " "
#         )
#     }
#     if (!exists("my_replicates_sorted")) {
#         warn <- paste("Variables 'my_replicates_sorted'",
#                 "missing: Please run on_plate_selection() first",
#                 sep = " "
#         )
#     }
#     if (!(exists("my_data"))) {
#         warn <- paste("Variable 'my_data'",
#                 "missing: Please run load_maxQuant() first",
#                 sep = " "
#         )
#     }
#     return(warn)
# }

#' @export
#'
#' @title pipeline with report generation
#' @description
#' Loads user's data, prompt a graphical representation of a 96
#' well plate and let the user select where the duplicates of each
#' condition were placed. Use for reordering excel file.
#' Plate image with selection can also be saved in the form of a png
#' file in the output_MQ directory.
#'
#' Also generates a complete report with the graphics
#' @import prettydoc
#'
#' @name pipeline
#' @rdname pipeline
#' @aliases pipeline
#' @usage
#' pipeline(filepath,sheet_name=NULL,number_of_replicates,number_of_conditions,
#' control=FALSE,save.files=TRUE,MACSQuant.obj=NULL)
#' @param filepath path of the excel file
#' @param sheet_name Name of the sheet to load
#' (optional, first sheet is default)
#' @param number_of_replicates For each condition, the number of duplicates
#' (must be the same for all conditions)
#' @param number_of_conditions The number of conditions tested
#' (eg: Drug 1 alone, Drug 2 alone)
#' @param control Is there a control in this experiment (eg: Staurosporin)
#' @param save.files Used to save the image in the output folder
#' @param MACSQuant.obj object of class MACSQuant
#'
#' @examples
#' print("run manually, requires user input")
#' filepath <- system.file("extdata", "SingleDrugs.xlsx",
#'     package = "MACSQuantifyR")
#' # pipeline(filepath,3,5)
#' # let you select 5 conditions of 3 replicates each
#' @return A formatted report file along with intermediates results

# source("./R/load_MACSQuant.R")

# source("./R/on_plate_selection.r")


pipeline <- function(filepath, sheet_name = NULL,
                        number_of_replicates,
                        number_of_conditions,
                        control = FALSE,
                        save.files = TRUE,
                        MACSQuant.obj = NULL) {

    MACSQuant <- load_MACSQuant.internal(filepath, sheet_name, MACSQuant.obj)

    MACSQuant <- on_plate_selection.internal(MACSQuant,
        number_of_replicates,
        number_of_conditions,
        control,
        save.files)

    if (save.files == TRUE) {
        generate_report(MACSQuant)
    }
    return(MACSQuant)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_report.r
\name{generate_report}
\alias{generate_report}
\title{Word report generation}
\usage{
generate_report(MACSQuant)
}
\arguments{
\item{MACSQuant}{object of class MACSQuant resulting of the function
load_maxQuant().
Contains the original data table}
}
\value{
A formatted report
}
\description{
Allows the user to generate a report at every
steps of the analysis

Also generates a complete report with the graphics
}
\examples{
drugs_R_image <- system.file("extdata",
    "drugs.RDS",
    package = "MACSQuantifyR")
MACSQuant <- readRDS(drugs_R_image)
generate_report(MACSQuant)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessor_function_toolbox.R
\name{rData}
\alias{rData}
\title{accessor function to access raw data}
\usage{
rData(MACSQuant)
}
\arguments{
\item{MACSQuant}{object of class MACSQuant resulting of the function
load_maxQuant().
Contains the original data table}
}
\value{
the raw data table
}
\description{
This function allows the user to access raw data table
}
\examples{
filepath <- system.file("extdata", "SingleDrugs.xlsx",
    package = "MACSQuantifyR")
#MACSQuant = load_MACSQuant(filepath)

#rData(MACSQuant)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_MACSQuant.R
\name{load_MACSQuant}
\alias{load_MACSQuant}
\title{Load xls file from maxQuant 96-well-plate device}
\usage{
load_MACSQuant(filepath,sheet_name= NULL,MACSQuant.obj= NULL)
}
\arguments{
\item{filepath}{path of the excel file}

\item{sheet_name}{Name of the sheet to load
(optional, first sheet is default)}

\item{MACSQuant.obj}{object of class MACSQuant}
}
\value{
An object called MACSQuant of class MACSQuant containing
variable my_data that corresponds to the data of the excel file in R
}
\description{
Load xls file from maxQuant 96-well-plate device
}
\examples{
filepath <- system.file("extdata", "SingleDrugs.xlsx",
    package = "MACSQuantifyR")
# load_MACSQuant(filepath)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/new_class_MQ.R
\name{new_class_MQ}
\alias{new_class_MQ}
\title{Create a new MACSQuant object}
\usage{
#initialize empty MACSQuant object
new_class_MQ(my_data=NULL,my_data_sorted=NULL,my_replicates_sorted=NULL,
experiment_name=NULL,statistics=NULL,combination.index.df=NULL,
number_of_replicates=NULL,number_of_conditions=NULL,doses=NULL,
doses.alt=NULL,c_names=NULL, control=NULL,plt.title=NULL,
plt.labels=NULL,plt.col=NULL,save.files=NULL,path=tempdir())
#initialize custom MACSQuant object
new_class_MQ(my_data,my_data_sorted=NULL,my_replicates_sorted=NULL,
experiment_name=NULL,statistics=NULL,combination.index.df=NULL,
number_of_replicates=NULL,number_of_conditions=NULL,
doses=NULL,doses.alt=NULL, c_names=NULL,control=NULL,plt.title=NULL,
plt.labels=NULL,plt.col=NULL, save.files=NULL,path=tempdir())
}
\arguments{
\item{my_data}{Contains the raw data}

\item{my_data_sorted}{Contains the sorted data
(according to replicates order)}

\item{my_replicates_sorted}{Contains the sorted matrix containing
replicates names}

\item{experiment_name}{User defined experiment named. Used for the
report generation}

\item{statistics}{Contains the statistics for each condition}

\item{combination.index.df}{data.frame that contains the outputs of
the combination_index function}

\item{number_of_replicates}{For each condition, the number of duplicates
(must be the same for all conditions)}

\item{number_of_conditions}{The number of conditions tested
(eg: Drug 1 alone, Drug 2 alone)}

\item{doses}{Numeric vector representing doses for each conditions}

\item{doses.alt}{In case of interaction test second dose vector}

\item{c_names}{Vector containing experiment names}

\item{control}{logical: is there a control in this experiment
(eg: Staurosporin)}

\item{plt.title}{Title of the experiment to add to the barplot}

\item{plt.labels}{legend labels for the bar plot}

\item{plt.col}{color vector for the graphical representations}

\item{save.files}{Used to save the image in the output folder}

\item{path}{path of the experiment output folder (default '.')}
}
\value{
A formatted report file along with intermediates results
}
\description{
The user can create a new custom MACSQuant object
This function is also used in internal code for
MACSQuant initialization
}
\examples{
# initialize empty MACSQuant object
new_class_MQ()
# initialize custom MACSQuant object
my_data <- data.frame(character(length = 10), character(length = 10),
    numeric(length = 10), numeric(length = 10))
names(my_data) <- c("Full path", "WID", "\%-#", "Count/mL")
new_class_MQ(my_data)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combination_index.R
\name{combination_index}
\alias{combination_index}
\title{compute combination index}
\usage{
combination_index(MACSQuant, ...)
}
\arguments{
\item{MACSQuant}{object of class MACSQuant resulting of the function
load_maxQuant().
Contains the original data table}

\item{...}{params for lattice cloud namely z and x for parameter screen
default for z and x are c(-110,-70) and argument xlab and ylab}
}
\value{
Several plots and combination index
}
\description{
This function allows the user to compute combination index
on the drug combinations. This function also generates intermediary
plots and tables.
}
\examples{
filepath <- system.file("extdata", "drugs.Rdata",
    package = "MACSQuantifyR")
load(filepath)
combination_index(MACSQuant)
}
\references{
Chou, T. C. (2006). Theoretical basis, experimental design, and
computerized simulation of synergism and antagonism in drug
combination studies. \emph{Pharmacological reviews}, 58(3), 621-681.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pipeline.R
\name{pipeline}
\alias{pipeline}
\title{pipeline with report generation}
\usage{
pipeline(filepath,sheet_name=NULL,number_of_replicates,number_of_conditions,
control=FALSE,save.files=TRUE,MACSQuant.obj=NULL)
}
\arguments{
\item{filepath}{path of the excel file}

\item{sheet_name}{Name of the sheet to load
(optional, first sheet is default)}

\item{number_of_replicates}{For each condition, the number of duplicates
(must be the same for all conditions)}

\item{number_of_conditions}{The number of conditions tested
(eg: Drug 1 alone, Drug 2 alone)}

\item{control}{Is there a control in this experiment (eg: Staurosporin)}

\item{save.files}{Used to save the image in the output folder}

\item{MACSQuant.obj}{object of class MACSQuant}
}
\value{
A formatted report file along with intermediates results
}
\description{
Loads user's data, prompt a graphical representation of a 96
well plate and let the user select where the duplicates of each
condition were placed. Use for reordering excel file.
Plate image with selection can also be saved in the form of a png
file in the output_MQ directory.

Also generates a complete report with the graphics
}
\examples{
print("run manually, requires user input")
filepath <- system.file("extdata", "SingleDrugs.xlsx",
    package = "MACSQuantifyR")
# pipeline(filepath,3,5)
# let you select 5 conditions of 3 replicates each
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/on_plate_selection.r
\name{on_plate_selection}
\alias{on_plate_selection}
\title{Sort experimental design on graphical 96-well-plate}
\usage{
on_plate_selection(MACSQuant,number_of_replicates,number_of_conditions,
control=FALSE,save.files=FALSE)
}
\arguments{
\item{MACSQuant}{object of class MACSQuant resulting of the function
load_maxQuant().
Contains the original data table}

\item{number_of_replicates}{For each condition, the number of duplicates
(must be the same for all conditions)}

\item{number_of_conditions}{The number of conditions tested
(eg: Drug 1 alone, Drug 2 alone)}

\item{control}{Is there a control in this experiment (eg: Staurosporin)}

\item{save.files}{Used to save the image in the output folder}
}
\value{
A formatted report file along with intermediates results
}
\description{
Loads user's data, prompt a graphical representation of a 96
well plate and let the user select where the duplicates of each
condition were placed. Use for reordering excel file.
Plate image with selection can also be saved in the form of a png
file in the "specified_path/output_MQ" directory.
}
\examples{
print("run manually, requires user input")
# on_plate_selection(MACSQuant,3,5)
# let you select 5 conditions of 3 replicates each
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class_MQ.R
\docType{class}
\name{MACSQuant}
\alias{MACSQuant}
\alias{MACSQuant-class}
\title{The MACSQuant Class}
\description{
MACSQuant object contains all the data and the user parameters
}
\section{Slots}{

\describe{
\item{\code{my_data}}{Contains the raw data}

\item{\code{my_data_sorted}}{Contains the sorted data
(according to replicates order)}

\item{\code{my_replicates_sorted}}{Contains the sorted matrix containing
replicates names}

\item{\code{experiment_name}}{Contains the experiment name
given by the user}

\item{\code{statistics}}{Contains the statistics for each condition}

\item{\code{combination.index.df}}{data.frame that contains the outputs of
the combination_index function}

\item{\code{param.experiment}}{list that contains the parameters relative
to the experiment (i.e, number of replicates,
number of conditions...)}

\item{\code{param.output}}{List that contains the parameters relative
to the report generation and outputs (i.e, save intermediary
results, generate full report..)}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/barplot_data.R
\name{barplot_data}
\alias{barplot_data}
\title{Generate barplots}
\usage{
barplot_data(MACSQuant,plt.col=NULL,plt.conditions=NULL, plt.flavour=NULL,
plt.labels = NULL, plt.combo=FALSE,plt.3D.only = NULL,...)
}
\arguments{
\item{MACSQuant}{object of class MACSQuant resulting of the function
load_maxQuant().
Contains the original data table}

\item{plt.col}{In case of manual run is used to define the bar colors.
(must be the same for all conditions)}

\item{plt.conditions}{user defined vector of conditions to plot
(example: plt.conditions=c(1:9))}

\item{plt.flavour}{Which barplot to produce, cell count or percentage of
fluorochrome
(i.e: "counts","percent")}

\item{plt.labels}{xlabels of the plot}

\item{plt.combo}{Does the experiment involves multiple variables
(i.e some condition are a drug combination screening)}

\item{plt.3D.only}{Whether to plot 3D barplot alone}

\item{...}{params for lattice cloud namely z and x for parameter screen
default for z and x are c(-110,-70) and argument xlab and ylab}
}
\value{
returns a barplot of the data
}
\description{
Uses the informations stored in the statistic tables of
the MACSQuant object to generate barplots for the specified
conditions. Plots can also be saved in the form of a png
file in the output_MQ directory.
}
\examples{
drugs_R_image <- system.file("extdata",
    "drugs.RDS",
    package = "MACSQuantifyR")
MACSQuant <- readRDS(drugs_R_image)
flavour <- "counts"
number_of_conditions <-
    slot(MACSQuant, "param.experiment")$number_of_conditions
plt.col <- c(rep(2, number_of_conditions), 1)
barplot_data(MACSQuant,
    plt.col = plt.col,
    plt.conditions = NULL,
    plt.flavour = flavour,
    plt.labels = NULL,
    plt.combo = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessor_function_toolbox.R
\name{setPath}
\alias{setPath}
\title{sets custom output path}
\usage{
setPath(MACSQuant,path=NULL)
}
\arguments{
\item{MACSQuant}{object of class MACSQuant resulting of the function
load_maxQuant().
Contains the original data table}

\item{path}{user defined path, default is tempd}
}
\value{
object of class MACSQuant with updated path
}
\description{
This function allows the user to set the output directory path
}
\examples{
filepath <- system.file("extdata", "SingleDrugs.xlsx",
    package = "MACSQuantifyR")
#MACSQuant = load_MACSQuant(filepath)
user_path="."
#MACSQuant = setPath(MACSQuant,path=user_path)
}
